/*
	C2py() gets a Python's function name and arguments and call this function.
	It returns the value returned by the Python's function.
*/

#include "Python.h"
#include <stdarg.h>

static PyObject *pModule = NULL;

static int import_python_module(char *name)
{
	PyObject *pName = PyString_FromString(name);

	if (pName == NULL)
		return 1;

	pModule = PyImport_Import(pName);
	Py_DECREF(pName);

	return (pModule ? 0 : 1);
}

void *C2py (char *func, int nargs, ...)
{
	PyObject *pFunc;
	PyObject *pArgs, *pValue;
	va_list ap;
	int i;
printf("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
printf("func %s, nargs %d\n", func, nargs);

	va_start (ap, nargs);         /* Initialize the argument list. */

	pFunc = PyObject_GetAttrString(pModule, func);

	/* pFunc is a new reference */
	if (!pFunc || !PyCallable_Check(pFunc)) {
		if (PyErr_Occurred())
			PyErr_Print();

		fprintf(stderr, "Cannot find function \"%s\"\n", func);
	}

	pArgs = PyTuple_New(nargs);
	for (i = 0 ; i < nargs ; i++) {
		pValue = va_arg(ap, PyObject *);
		/* pValue reference stolen here: */
		PyTuple_SetItem(pArgs, i, pValue);
	}

	pValue = PyObject_CallObject(pFunc, pArgs);

	/* Clean up. */
    if (pArgs)
	    Py_DECREF(pArgs);
	Py_DECREF(pFunc);
	va_end (ap);

    if (pValue == NULL) {
printf("ERRORERRORERRORERRORERRORERRORERRORERRORERRORERRORERRORERRORERRORERRORERRORERRORERRORERRORERRORERROR\n");
        PyErr_Print();
    }

	return (void *)pValue;
}

int python_instance_constructor(char *python_module_name)
{
	char *ph = "PYTHONPATH";
	char *ph_value;

	ph_value = getenv(ph);
	setenv(ph, ".", 1);

	Py_Initialize();

        if (import_python_module(python_module_name)) {
		PyErr_Print();
		fprintf(stderr, "Failed to load \'%s\' module\n", python_module_name);
		return -1;
	}

	setenv(ph, ph_value, 1);

	return 0;
}

void python_instance_destructor(void)
{
    // FIXME: This call ends up with weird exception thrown
	// Py_Finalize();
}
