#!/usr/bin/perl

my %env = (
	'arch' => 'nP7510'
);

my %specsigns = (
'('						=> LPAREN,
')'						=> RPAREN,
'{'						=> LBRACE,
'}'						=> RBRACE,
'['						=> LBRACKET,
']'						=> RBRACKET,
','						=> COMMA,
':'						=> COLON,
';'						=> SEMI,
'*'						=> STAR,
'='						=> ASSIGN,
'<'						=> LT,
'>'						=> GT,
'?'						=> QUESTION,
'&'						=> AND,
'|'						=> OR,
'^'						=> XOR,
'+'						=> PLUS,
'-'						=> MINUS,
'%'						=> MOD,
'/'						=> DIV,
'!'						=> EXCL,
'~'						=> TILDA,
'.'						=> DOT,
);

sub get_rules
{
	my ($yfilename) = @_;
	my @tokens = ();
	my @tokens2 = ();
	my @other_tokens = ();
	my $sync_keyword = {};
	my $ckeys = {};


	open(F, $yfilename) || die "cannot open file '$yfilename'";
	my @f = <F>;
	close(F);

	my $f = join '', map { s/#.*// ; $_ } grep !/^\s*#/, @f;


	my ($first_part, $second_part) = ($f =~ /(.+?)^%%\n(.+?)^%%\n/ms);
	my $start = '';
	my @rules = ();

	$first_part .= "%";
	my @tables = ($first_part =~ /^%(\w+)\n(.+?)\n\n(?=%)/gms);

	@tables = map { s/\n{2,}/\n/g; $_ } @tables;

print "size = " , scalar(@tables), "\n";
print "$tables[0], $tables[2]\n";
	for (my $i = 0 ; $i < @tables ; $i += 2) {
		if ($tables[$i] eq 'token') {
print "in token\n";
			for my $pair (split("\n", $tables[$i + 1])) {
				my ($k, $v) = split(/\s+/, $pair);
print "insert 0 $k, $v\n";
				push @tokens, [$k, $v];
			}
		} elsif ($tables[$i] eq 'token2') {
print "in token\n";
			for my $pair (split("\n", $tables[$i + 1])) {
				my ($k, $v) = split(/\s+/, $pair);
print "insert 0 $k, $v\n";
				push @tokens2, [$k, $v];
			}
		} elsif ($tables[$i] eq 'keyword') {
			my @pairs = split("\n", $tables[$i + 1]);
			for my $pair (@pairs) {
				my ($k, $v) = split(/\s+/, $pair);
				push @tokens, [$k, $v];
print "insert 1 $k, $v\n";
				$ckeys->{$k} = $v;
			}
		} elsif ($tables[$i] eq 'sync_keyword') {
			my @pairs = split("\n", $tables[$i + 1]);
			for my $pair (@pairs) {
				my ($k, $v) = split(/\s+/, $pair);
				push @tokens, [$k, $v];
print "insert 2 $k, $v\n";
				$ckeys->{$k} = $v;
				$sync_keyword->{$k} = $v;
			}
		} elsif ($tables[$i] eq 'other_token') {
print "push to other $tables[$i + 1]\n";
			push @other_tokens, $tables[$i + 1];
		} elsif ($tables[$i] eq 'start') {
			$start = $tables[$i + 1];
		}
	}

	while ($second_part =~ /(^(\w+)\s*:(\s+).+?\3;)/gms) {
		push @rules, $1;
	}

	return ($start, \@rules, \@tokens, \@tokens2, \@other_tokens, $ckeys, $sync_keyword);
}

sub get_default_action
{
	my ($debug_info) = @_;

	my $action = << "END";
	{
		\$\$ = \$1;
$debug_info
	}
END
	return $action;
}

sub get_parser_first_part
{
	my ($start, $tokens, $other_tokens) = @_;
	my $fp = << "END";
\%{
#include <iostream>
#include <string>

extern int lineno;
extern char filename[];

extern void *C2py(char *, int, ...);

extern std::string get_sync_token() ;
extern bool at_eof() ;

extern int yylex();
static void yyerror(const char *s);
#define YYSTYPE void *
\%}

END

	my @t = map { ($_->[1] =~ /^[_A-Z\d]+$/) ? $_->[1] : () } @{$tokens};
	push @t, @{$other_tokens};

	my $n_tokens_per_line = 6;

	for (my $i = 0 ; $i < @t ; $i += $n_tokens_per_line) {
		$fp .= '%token ' . join(' ', @t[$i .. $i + $n_tokens_per_line - 1]) . "\n";
	}

	$fp =~ s/\s+$/\n/;

	$fp .= "\n%start $start\n\n%%\n";

	return $fp;
}

sub build_new_rules
{
	my ($start, $rules, $ckeys) = @_;

	my %rules = ();
	my %graph = ();

	if (not defined $start) {
		($start) = ($rules->[0] =~ /^(\w+)\s*:/);
	}

print "xexe0\n";

	for my $rule (@{$rules}) {
print ">$rule<\n";
		my ($nt, $sp, $subrules) = ($rule =~ /^(\w+)\s*:(\s+)(.+)/s);
		my @subrules = ();
		my $sr;

print "$nt rule is >$rule<\n";
		$rules{$nt} = $rule;

		@subrules = split '\n\t\| ', $subrules;
		for (@subrules) {
			s/$sp\{.+?$sp\}\n/ /sg;
		}
		$subrules[-1] =~ s/\s+;\s*$//;

print("def: no children for $nt\n");
		$graph{$nt}{child} = {};

		for $sr (@subrules) {
print("sr = >>$sr<<\n");
			($sr) = ($sr =~ /(^.+)/);

print("sr999 = >>$sr<<\n");
			while ($sr =~ /\b([a-z]\w*)\b/g) {
				if ($1 ne 'error') {
print("def: $nt\[$1\]\n");
					$graph{$nt}{child}{$1} = 1;
				}
			}
		}

		$graph{$nt}{color} = 0;
	}

print "xexe %{$graph{'constant_expression'}{child}}\n";
	# BFS

print "haha 0 $rules{'arch_dependent_statement'}\n";
	my $new_r = [];
	my @node_queue = ($start);
	$graph{$start}{color} = 1;

	for my $node (@node_queue) {
print "abc: $node-> ";
		for my $child (keys(%{$graph{$node}{child}}))  {
print "$child ";
			if ($graph{$child}{color} == 0) {
				$graph{$child}{color} = 1;
				push @node_queue, $child;
			}
		}
print "\n";
	}

print "haha 1 $rules{'arch_dependent_statement'}\n";
	my @kw = grep { exists $ckeys->{$_} } @node_queue;
	my @nonkw = grep { not exists $ckeys->{$_} } @node_queue;

	@node_queue = (@nonkw, @kw);

print "haha 2 $rules{'arch_dependent_statement'}\n";
	for my $node (@node_queue) {
if (not exists $rules{$node} or length($rules{$node}) == 0) {
print "blya >$node<\n";
}
		if (exists $rules{$node}) {
			push @{$new_r}, $rules{$node};
		}
	}

	return $new_r;
}

sub get_parser_second_part
{
	my ($start, $rules, $ckeys) = @_;
	my $new_rules = build_new_rules($start, $rules, $ckeys);
	# Hash 'cbfunctions' was introduced because of the following rule
	# initializer:
	# assignment_expression
	# | '{' initializer_list '}'
	# | '{' initializer_list ',' '}'
	# ;
	# two last rules call the same function and it should be defined only once.
	my %cbfunctions = ();
	my $python_code = '';
	my $sp = '';

	my $push_context = '{ C2py("push_scalar_context", 0); }';
	my $pop_context = '{ C2py("pop_context", 0); }';
	my $push_while_construct = '{ C2py("push_while_construct", 0); }';
	my $push_do_construct = '{ C2py("push_do_construct", 0); }';
	my $push_for_construct = '{ C2py("push_for_construct", 0); }';
	my $push_cs_construct = '{ C2py("push_cs_construct", 0); }';
	my $reset_context = '{ C2py("reset_context", 0); }';

	my %exception = (
					'translation_unit' => '',
					'assignment_expression' => 'expression',
					'declaration_specifiers' => 'data_type',
					'declaration' => 'declaration_list',
					'parameter_declaration' => 'parameter_list',
					'statement' => 'statement_list',
					'expression' => 'expression_top',
					'conditional_expression' => 'conditional_expression_top',
					'type_specifier' => 'declaration_specifiers',
					'declarator' => 'init_declarator',
					'init_declarator' => 'init_declarator_list',
					'assembly_instruction' => '',
					'rf_reg_name' => '',
					'tr_reg_name' => '',
					'mp_reg_name' => '',
					'sp_reg_name' => '',
					'integer' => '',
					'var_name' => '',
					);
					# 'identifier' => '',
	my %super_exception = (
					'void' => '',
					'char' => '',
					'short' => '',
					'int' => '',
					'long' => '',
					'signed' => '',
					'unsigned' => '',
					);

print '!' x 80 . "\n";
for (@{$new_rules}) {
	print $_ . "\n";
}
print "eks : @{[keys %exception]}\n";

print '#' x 80 . "\n";
	for my $rule (@{$new_rules}) {
print ">$rule<\n";
		my ($nt, $subrules) = ($rule =~ /^(\w+)\s*:\s+(.+)/s);
		my @subrules = ();
		my $sr;

		@subrules = split '\n\t\| ', $subrules;

		if (@subrules) {
			$subrules[-1] =~ s/\s+;\s*$//;
		}

		@subrules = map { s/ {2,}/ /g; $_ } @subrules;
# else {
# print "nt = $nt\n"
# }

		my $last_action = '';
		my $new_rule = '';
		my $func_name = '';

		for (my $i = 0 ; $i < @subrules ; $i++) {
			$sr = $subrules[$i];
print("sr0 = >>$sr<<\n");

			$func_name = $sr;
			$func_name =~ s/',' +//g;

			for my $k (keys %specsigns) {
				my $v = '\\' . $k;
				$func_name =~ s/\'$v\'/$specsigns{$k}/g;
			}

if (0) {
			if ($nt eq 'iteration_statement') {
				($sr =~ s/(while\s+'\('\s+)(expression\s+'\)')/$1PUSH_CONTEXT $2 POP_CONTEXT/) or
				($sr =~ s/(';'\s+)(expression\s+';')/$1PUSH_CONTEXT $2 POP_CONTEXT/);
			} elsif ($nt eq 'selection_statement') {
				$sr =~ s/(if\s+'\('\s+)(expression\s+'\)')/$1PUSH_CONTEXT $2 POP_CONTEXT/;
			} elsif ($nt eq 'postfix_expression') {
				$sr =~ s/(identifier\s+'\('\s+)(expression\s+'\)')/$1PUSH_CONTEXT $2 POP_CONTEXT/;
			} elsif ($nt eq 'multiplicative_expression') {
				$sr =~ s/([a-zA-Z]+\s+)(multiplicative_expression)/$1PUSH_CONTEXT $2 POP_CONTEXT/;
			} elsif ($nt eq 'assignment_expression') {
				$sr =~ s/([a-zA-Z]+\s+)(assignment_expression)/$1PUSH_CONTEXT $2 POP_CONTEXT/;
			}
}
			if ($nt eq 'iteration_statement') {
				if ($sr !~ /error/) {
					($sr =~ s/(while.+?)(statement)/$1PUSH_WHILE_CONSTRUCT $2/) or
					($sr =~ s/(do\s+)(statement)/$1PUSH_DO_CONSTRUCT $2/) or
					($sr =~ s/(for.+?)(statement)/$1PUSH_FOR_CONSTRUCT $2/);
				}
			# } elsif ($nt eq 'compound_statement') {
				# $sr =~ s/('\{' +)(\S+)/$1PUSH_CS_CONSTRUCT $2/;
			}

print("sr1 = >>$sr<<\n");
			my @all = ($sr =~ /(\S+)/g);
			# special treatment for assembly_instruction non-terminal
			my @nonterm = ($nt eq 'assembly_instruction') ? ($sr =~ /([a-zA-Z]\w*)/g) : ($sr =~ /([a-z]\w*)/g);
			@nonterm = grep { not exists $ckeys->{$_} } @nonterm;
			my $n_nonterm = @nonterm;
			my %index0 = ();
			my %index1 = ();
			my %index2 = ();
			my @python_args = ();
			my $python_args = '';
print("nonterm = >>@nonterm<<\n");

			for (@nonterm) {
				for (my $i = 0 ; $i < @all ; $i++) {
					if ($_ eq $all[$i]) {
						push @{$index0{$_}}, $i + 1;
						push @{$index1{$_}}, $i + 1;
						push @{$index2{$_}}, $i + 1;
					}
				}
			}

			for (keys %index2) {
				if (@{$index2{$_}} > 1) {
					push @{$index2{$_}}, 0;
				}
			}

			for (@nonterm) {
				for (my $i = 0 ; $i < @all ; $i++) {
					if ($_ eq $all[$i]) {
						push @python_args, $_ . ((@{$index2{$_}} > 1) ? shift(@{$index2{$_}}) : '');
						last;
					}
				}
			}

			$python_args = join ', ', @python_args;

			my $new_sr = $sr;
			$new_sr =~ s/PUSH_CONTEXT/$push_context/g;
			$new_sr =~ s/POP_CONTEXT/$pop_context/g;
			$new_sr =~ s/PUSH_WHILE_CONSTRUCT/$push_while_construct/g;
			$new_sr =~ s/PUSH_DO_CONSTRUCT/$push_do_construct/g;
			$new_sr =~ s/PUSH_FOR_CONSTRUCT/$push_for_construct/g;
			$new_sr =~ s/PUSH_CS_CONSTRUCT/$push_cs_construct/g;

			$new_rule .= "\t| $new_sr\n";

			# write Yacc rules and Python callbacks
			my $debug_info = "std::cerr << \"$nt: $sr -> \" << \$\$ << std::endl";

			if ($sr =~ /\berror\b/) {
				$sr =~ s/ /__/g;
				$new_rule .= << "END";
	{
		\$\$ = NULL;
$debug_info
	}
END
			} elsif (exists $super_exception{$sr}) {
					$func_name =~ s/ /__/g;
					$func_name = $nt . '__' . $func_name;
					$new_rule .= << "END";
	{
		\$\$ = C2py("$func_name", 0);
$debug_info
	}
END
					if (not exists $cbfunctions{$func_name}) {
						$cbfunctions{$func_name} = 0;
						$python_code .= "def $func_name($python_args):\n\treturn 0\n\n";
					}
			} elsif ($n_nonterm) {
				if ($nt ne 'expression_statement' and
					($sr !~ /^[a-z]\w*$/ or (exists $exception{$sr} and ($exception{$sr} eq '' or $exception{$sr} eq $nt)))) {
					$func_name =~ s/ /__/g;
					$func_name = $nt . '__' . $func_name;
					$new_rule .= << "END";
	{
		if (@{[ join(" && ", map { '$' . shift(@{$index0{$_}}) } @nonterm) ]}) {
			\$\$ = C2py("$func_name", $n_nonterm, @{[ join(", ", map { '$' . shift(@{$index1{$_}}) } @nonterm) ]});
		} else {
			\$\$ = NULL;
		}
$debug_info
	}
END
					if (not exists $cbfunctions{$func_name}) {
						$cbfunctions{$func_name} = 0;
						$python_code .= "def $func_name($python_args):\n\treturn 0\n\n";
					}
				# } else {
					# $new_rule .= get_default_action($debug_info);
				}
			} else {
				if (($sr !~ /^(\w+|'.')$/ and not exists $ckeys->{$nt}) or
					 ($nt eq 'expression_statement' and $sr eq "';'")) {
					$func_name =~ s/ /__/g;
					$func_name = $nt . '__' . $func_name;
					$new_rule .= << "END";
	{
		\$\$ = C2py("$func_name", $n_nonterm);
$debug_info
	}
END
					if (not exists $cbfunctions{$func_name}) {
						$cbfunctions{$func_name} = 0;
						$python_code .= "def $func_name():\n\treturn 0\n\n";
					}
				# } else {
					# $new_rule .= get_default_action($debug_info);
				}
			}
		}

		$new_rule =~ s/\t\| /$nt:\n\t/;
		$new_rule .= "\t;\n\n";
		$new_rule =~ s/ \{ +([^{]+?) +\}\n\t\{\n/\n\t{\n\t\t$1\n\n/g;
print("new_rule = >>$new_rule<<\n");

		$sp .= $new_rule;
		# print '# ' . '>' x 80 . "\n";
	}

	return ($sp, $python_code);
}

sub get_parser_third_part
{
	my $marker = '#' x 80 ;
	my $tp = << "END";
%%

static void
yyerror(const char *s)
{
	std::cerr << "$marker" << std::endl;
	if (at_eof()) {
		std::cerr << "error in file '" << filename << "', line " << lineno << " : syntax error at the end of the file" << std::endl ;
	} else {
		std::cerr << "error in file '" << filename << "', line " << lineno << " : syntax error near '" << get_sync_token() << "'" << std::endl ;
	}
}
END

	return $tp;
}

sub get_lexer_first_part
{
	my $fp = << "END";
%\{
// #include <ctype.h>
// #include <stdio.h>
#include "Python.h"
#include <iostream>
#include <string>

#include "parser.h"
#include "cmm_error.h"

extern int lineno;
extern char filename[];
static int scopeno = 0;
static int auxiliary_token = 0;
static bool eof = false;

static int semantic_value_set = 0;
static int process_eof();
static int process_unexpected_character();
static int process_token(int token);
%\}

\%x comment
\%\%
END

	return $fp;
}

sub get_lexer_second_part
{
	my ($tokens) = @_;

	my $sp = << "END";

\\/\\*													{ BEGIN(comment); }
<comment>[^*\\n]*										{}
<comment>\\*+[^*/\\n]*									{}
<comment>\\n												{ lineno++; }
<comment>\\*+\\/											{ BEGIN(INITIAL); }
<comment><<EOF>>										{ error(ERROR_EOF_IN_COMMENT, ""); yyterminate(); }
^#\\ [1-9][0-9]*\\ \\"[a-zA-Z_\\.][a-zA-Z_\\.0-9]*\\".*\\n		{ sscanf(yytext, "# \%d \\"\%s", &lineno, filename); *(strchr(filename, '"')) = '\\0'; }
\\n														{ lineno++; }
\\/\\/.*													{}
[\\t\\f\\v\\r ]+											{ /* Ignore whitespace. */ }

END

	for my $pair (@{$tokens}) {
		my ($k, $v) = @{$pair};
		my $n_spaces = 16 > length($k) ? 16 - length($k) : 80 - length($k);
		my $n_tabs = ($n_spaces >> 2) + 1 - ((($n_spaces % 4) == 0) ? 1 : 0);
		$sp .= $k . "\t" x $n_tabs . "{ return process_token($v); }\n"
	}

	$sp .= << "END";

<<EOF>>				{ return process_eof(); }
.					{ return process_unexpected_character(); }

%%

END

	return $sp;
}

sub get_lexer_third_part
{
	my ($sync_keyword) = @_;
	my $tp = << "END";

static int set_semantic_value(const char *s, int size)
{
	PyObject *pValue = PyString_FromString(s);
// printf("s = \%s, ", s);

	if (!pValue) {
		fprintf(stderr, "Cannot convert \%s to Python object\\n", s);
		yyterminate();
	}

	yylval = (YYSTYPE)pValue;
	semantic_value_set = 1;
// printf("yylval = \%p\\n", yylval);

	return 0;
}

static int process_eof()
{
	eof = 1;
printf("we are in '\%s'\\n", __func__);
	if (scopeno > 0) {
	  error(ERROR_CLOSING_CURLY_BRACKET_MISSING, "");
	}

	yyterminate();

	// return UNEXPECTED_CHAR;
}

static int process_unexpected_character()
{
	char error_message[4];
	sprintf(error_message, "'\%c'", yytext[0]);

	error(ERROR_UNEXPECTED_CHARACTER, error_message);

	yyterminate();
}

static int process_token(int token)
{
	if (auxiliary_token) {
		token = auxiliary_token;
		auxiliary_token = 0;
	} else {
		switch (token) {
END

	for (sort values %{$sync_keyword}) {
		my $n_spaces = 16 - length('case ') - length($_);
		my $n_tabs = ($n_spaces >> 2) + 1 - ((($n_spaces % 4) == 0) ? 1 : 0);
		$tp .= "\t\t\tcase $_" . "\t" x $n_tabs . ":\n";
	}

	$tp .= << "END";
					auxiliary_token = token;
					break;
			case '{'		:
					scopeno ++;
					break;
			case '}'		:
					scopeno --;
					break;
		}

		set_semantic_value(yytext, yyleng);

		if (auxiliary_token)
			yyless(0);
	}

	return token;
}

std::string get_sync_token()
{
	std::string sync_token("");

	if (auxiliary_token) {
	  switch (auxiliary_token) {
END

	for (sort values %sync_token) {
print "v $_\n";
# if ($_ eq 'TRM_DRT_MASK') {
# print $tp;
# exit;
# }
		my $n_spaces = 16 - length('case ') - length($_);
		my $n_tabs = ($n_spaces >> 2) + 1 - ((($n_spaces % 4) == 0) ? 1 : 0);
		my $t = $_;
		$t =~ tr/A-Z/a-z/;
		$tp .= "\t\t\tcase $_" . "\t" x $n_tabs . ":\n\t\t\t\tsync_token = \"$t\";\n\t\t\t\tbreak;\n";
	}

$tp .= << "END";
	  }
	}
	else {
	  sync_token = std::string(yytext);
	}

// std::cout << "sync_token = !" << sync_token << "!" << std::endl;

	return sync_token;
}

int at_eof()
{
	return eof;
}

int yywrap(void)
{
	return 1;
}

int lexer_constructor(const char *pc_in, const char *pc_out)
{
	if (!(yyin = fopen(pc_in, "r"))) {
		error(ERROR_CANNOT_OPEN_FILE, pc_in);
		return -1;
	}

	if (!(yyout = fopen(pc_out, "w"))) {
		fclose(yyin);
		error(ERROR_CANNOT_OPEN_FILE, pc_out);
		return -1;
	}

	lineno = 1;
	strcpy(filename, pc_in);

	return 0;
}

void lexer_destructor()
{
	  fclose(yyin);
	  fclose(yyout);
}
END

	return $tp;
}

sub process_parser_spec
{
	my ($parser_spec, $arch_parser_spec) = @_;

	my $parser = '';
	my $lexer = '';

	my ($start, $rules, $tokens, $tokens2, $other_tokens, $ckeys, $sync_keyword) = get_rules($parser_spec);
	my (undef, $arch_rules, $arch_tokens, undef, undef, $arch_ckeys, $arch_sync_keyword) = get_rules($arch_parser_spec);

	push @{$tokens}, (@{$arch_tokens}, @{$tokens2});
	$sync_keyword = {%{$sync_keyword}, %{$arch_sync_keyword}};

	my $second_part;
	my $python_code;

	my $arch_second_part;
	my $arch_python_code;

	$parser .= get_parser_first_part($start, $tokens, $other_tokens);
	($second_part, $python_code) = get_parser_second_part($start, $rules, $ckeys);
	($arch_second_part, $arch_python_code) = get_parser_second_part(undef, $arch_rules, $arch_ckeys);
	$parser .= $second_part . "\n" . $arch_second_part;
	$parser .= get_parser_third_part();

	$lexer .= get_lexer_first_part();
	$lexer .= get_lexer_second_part($tokens);
	$lexer .= get_lexer_third_part($sync_keyword);

	return ($parser, $lexer, $python_code, $arch_python_code);
}

sub generate_file
{
	my ($filename, $message, $new_contents) = @_;

	if (open(F, "$filename")) {
		my @f = <F>;
		close(F);

		my $old_contents = join '', @f[4 .. $#f];
		if ($old_contents eq $new_contents) {
			return 0;
		}
	}

	open(F, ">$filename") || die "cannot open file '$filename': $!";
	print F $message;
	print F $new_contents;
	close(F);

	return 1;
}

sub generate_import_header
{
	my ($code) = @_;
	my @code = @{$code};

	my %module = ();

	for (@code) {
		while (/(\bCmm\w+\b)/g) {
			$module{$1} = 1;
		}
	}

    my $imp = '';
	for (sort keys %module) {
		$imp .= "from cmm.$_ import $_\n";
	}

	return $imp;
}

sub merge
{
	my ($sc_filename, $my_filename, $filename) = @_;

	open(F, $sc_filename) || die "cannot open file '$sc_filename': $!";
	my @sc = <F>;
	close(F);

	open(F, $my_filename) || die "cannot open file '$my_filename': $!";
	my @my = <F>;
	close(F);

	my $start;
	my $finish;

	my $i = 0;
	my $j = 0;

	# it is assumed that the orders of functions in  'my' and 'sc' are the same

	for (; $i < @my ; $i++) {
		if ($my[$i] =~ /^def /) {
			for ($j = 0 ; $j < @sc and $my[$i] ne $sc[$j]; $j++) {}

			if ($j == @sc) {
				next;
			}

			$start = $i + 1;
			$finish = $start;
	
			while ($finish < @my and $my[$finish] !~ /^def /) {
				$finish++;
			}
	
			$finish --;
	
			splice(@sc, $j + 1, 2, @my[$start .. $finish]) ;
	
			$i = $finish;
			$j += $finish - $start + 2;
		}
	}

    my $import_header = "\n" . generate_import_header(\@sc);

    for ($i = 0 ; $i < @sc and $sc[$i] =~ /^#/ ; $i++) {}

    splice(@sc, $i, 0, $import_header);

	open(F, ">$filename") || die "cannot open file '$filename': $!";
	print F @sc;
	close(F);
}

sub generate_sceleton_and_merge
{
	my ($filename, $message, $new_contents) = @_;

	my $sc_filename = $filename;
	$sc_filename =~ s/\w+$/sc/;

	my $my_filename = $filename;
	$my_filename =~ s/\w+$/my/;

	if (-f $my_filename) {
		if (generate_file($sc_filename, $message, $new_contents) or -M $my_filename < -M $filename) {
			merge($sc_filename, $my_filename, $filename);
		}
	} else {
		if (generate_file($sc_filename, $message, $new_contents)) {
			system("cp $sc_filename $filename");
		}
	}
}

sub main
{
	my $parser_file = 'parser.y';
	my $lexer_file = 'lexer.l';

	my $parser_spec = 'parser.spec';
	my $arch = $env{'arch'};
	my $arch_parser_spec = 'parser.' . $arch . '.spec';
	my ($parser, $lexer, $python_code, $arch_python_code) = process_parser_spec($parser_spec, $arch_parser_spec);

	my $file_prefix = 'Cmm';
	my $lang_python_file = $file_prefix . 'ParserLang.py';
	my $arch_python_file = $file_prefix . 'ParserA' . $arch . '.py';
	my $parser_callbacks_python_file = $file_prefix . 'ParserCallbacks.py';

	my $date = `date`;
	chomp($date);

	my $C_generated_message = "/*\n * This file was generated by $0 on $date\n */\n\n";
	my $py_generated_message = "#\n# This file was generated by $0 on $date\n#\n\n";

	generate_file($parser_file, $C_generated_message, $parser);

	generate_file($lexer_file, $C_generated_message, $lexer);

	generate_sceleton_and_merge($lang_python_file, $py_generated_message, $python_code);

	generate_sceleton_and_merge($arch_python_file, $py_generated_message, $arch_python_code);

	my $parser_aux_file = $file_prefix . 'ParserAux.py';
	my $imports .= "from $lang_python_file import *\n";
	$imports .= "from $arch_python_file import *\n";
	$imports .= "from $parser_aux_file import *\n";
	$imports .= "from CmmBackend import *\n";
        $imports .= "from cmm.CmmMisc import CmmMisc\n";
        $imports .= "CmmMisc.set_chip('$arch')\n";
	$imports =~ s/\.py//g;

	generate_file($parser_callbacks_python_file, $py_generated_message, $imports);
}

main();
