import py2C

class CmmError(object) :
    _err_msg_list = []

    @staticmethod
    def _gen_err_msg(err_message) :
        filename = py2C.get_filename()
        lineno = py2C.get_lineno()
        if (len(filename)) :
            return "Error   => file " + filename + ", line " + str(lineno) + " : " + err_message
        else :
            return "Error   : " + err_message


    def hash0(chip, *valid_chip_argument_values) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Chip argument has an invalid value '" + str(chip) + "'. Valid chip argument values are : 'nP7510', 'nP3700'.\n")]

    def hash1(function) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Function '" + function + "' is redefined.\n")]

    def hash2(var) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Global variable '" + var + "' is redefined.\n")]

    def hash3(function, var) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Local variable '" + var + "' in function '" + function + "' is redefined.\n")]

    def hash4(function, var) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Variable and argument have identical name '" + var + "' in function '" + function + "'.\n")]

    def hash5(function, arg) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Argument '" + arg + "' in function '" + function + "' is redefined.\n")]

    def hash6(label) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Duplicate label '" + label + "'.\n")]

    def hash7(function, var) :
        CmmError._err_msg_list += [CmmError._gen_err_msg(("Use of undeclared variable '" + var + "' in function '" + function + "'.\n") if length(function) else ("Use of undeclared global variable '" + var + "'.\n"))]

    def hash8() :
        CmmError._err_msg_list += [CmmError._gen_err_msg("A non constant is used where a constant was expected.\n")]

    def hash9(function, func) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Call for the undefined function '" + func + "'.\n")]

    def hash10(function, func) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Wrong number of arguments in function call for '" + func + "'.\n")]

    def hash11(function) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("++/-- cannot be applied to the function call for '" + function + "'.\n")]

    def hash12(nonvar) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("++/-- cannot be applied to '" + str(nonvar) + "'.\n")]

    def hash13(function) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Function '" + function + "' has no return statement.\n")]

    def hash14(function) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Function '" + function + "' to return no value.\n")]

    def hash15(function) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Function '" + function + "' to return a value.\n")]

    def hash16() :
        CmmError._err_msg_list += [CmmError._gen_err_msg("'continue' statement is not within loop.\n")]

    def hash17() :
        CmmError._err_msg_list += [CmmError._gen_err_msg("'break' statement is not within loop or 'switch' statement.\n")]

    def hash18() :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Unexpected 'case'.\n")]

    def hash19() :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Unexpected 'default'.\n")]

    def hash20() :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Unexpected variable declaration.\n")]

    def hash21(value) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Duplicate 'case' value " + str(value) + " in the 'switch' statement.\n")]

    def hash22() :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Multiple 'default' in the 'switch' statement.\n")]

    def hash23() :
        CmmError._err_msg_list += [CmmError._gen_err_msg("No cases in the 'switch' statement.\n")]

    def hash24(label) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("An attempt to use an undefined label '" + label + "'.\n")]

    def hash25() :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Invalid lvalue in assignment.\n")]

    def hash26() :
        CmmError._err_msg_list += [CmmError._gen_err_msg("'main' function is undefined.\n")]

    def hash27(function) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Out of line function '" + function + "' should return no value.\n")]

    def hash28(function) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Out of line function '" + function + "' should have no arguments.\n")]

    def hash29() :
        CmmError._err_msg_list += [CmmError._gen_err_msg("'main' function should must have no type specification.\n")]

    def hash30() :
        CmmError._err_msg_list += [CmmError._gen_err_msg("'main' function cannot be called.\n")]

    def hash31(function_name) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("'pcr' function '" + function_name + "' cannot be called.\n")]

    def hash32() :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Only 'gSH' entry is permitted as an 'lvalue' in pcr-assignment.\n")]

    def hash33() :
        CmmError._err_msg_list += [CmmError._gen_err_msg("'main' function is referenced in pcr-assignment.\n")]

    def hash34(function) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Undefined function '" + function + "' is referenced in pcr-assignment.\n")]

    def hash35(function) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Inline function '" + function + "' is referenced in pcr-assignment.\n")]

    def hash36(var) :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Use of undefined variable '" + var + "'.\n")]

    def hash37() :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Use of unset flag in 'pc' register.\n")]

    def hash38() :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Use of undefined struct tag.\n")]

    def hash39() :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Use of undefined union tag.\n")]

    def hash40() :
        CmmError._err_msg_list += [CmmError._gen_err_msg("Unexpected 'void'.\n")]

    _error_message = {
        'ERR_INVALID_CHIP_ARGUMENT'                         : hash0,
        'ERR_FUNCTION_REDEFINED'                            : hash1,
        'ERR_GLOBAL_VAR_REDEFINED'                          : hash2,
        'ERR_LOCAL_VAR_REDEFINED'                           : hash3,
        'ERR_VAR_ARG_REDEFINED'                             : hash4,
        'ERR_ARG_REDEFINED'                                 : hash5,
        'ERR_LABEL_REDEFINED'                               : hash6,
        'ERR_UNDECLARED_VAR'                                : hash7,
        'ERR_UNEXPECTED_NOT_CONST'                          : hash8,
        'ERR_UNDEFINED_FUNCTION'                            : hash9,
        'ERR_WRONG_NUMBER_OF_ARGS'                          : hash10,
        'ERR_INC_DEC_APPL_TO_FUNCALL'                       : hash11,
        'ERR_INC_DEC_APPL_TO_NONVAR'                        : hash12,
        'ERR_NO_RETURNS'                                    : hash13,
        'ERR_FUN_DEF_RETURN_NO_VALUE'                       : hash14,
        'ERR_FUN_DEF_RETURN_A_VALUE'                        : hash15,
        'ERR_UNEXPECTED_CONTINUE'                           : hash16,
        'ERR_UNEXPECTED_BREAK'                              : hash17,
        'ERR_UNEXPECTED_CASE'                               : hash18,
        'ERR_UNEXPECTED_DEFAULT'                            : hash19,
        'ERR_UNEXPECTED_VAR_DECL'                           : hash20,
        'ERR_DUPLICATE_CASE_VALUE'                          : hash21,
        'ERR_MULTIPLE_DEFAULTS'                             : hash22,
        'ERR_NO_CASE_IN_SWITCH'                             : hash23,
        'ERR_UNDEFINED_LABEL'                               : hash24,
        'ERR_INVALID_LVALUE_IN_ASSGNMNT'                    : hash25,
        'ERR_MAIN_FUNC_IS_UNDEFINED'                        : hash26,
        'ERR_OUT_FUNC_RETURNS_VALUE'                        : hash27,
        'ERR_OUT_FUNC_HAS_ARGS'                             : hash28,
        'ERR_MAIN_FUNC_SHOULD_HAVE_NO_TYPE'                 : hash29,
        'ERR_MAIN_FUNC_IS_CALLED'                           : hash30,
        'ERR_PCR_FUNC_IS_CALLED'                            : hash31,
        'ERR_BAD_LVALUE_IN_PCR'                             : hash32,
        'ERR_MAIN_FUNCTION_IN_PCR'                          : hash33,
        'ERR_UNDEFINED_FUNCTION_IN_PCR'                     : hash34,
        'ERR_INLINE_FUNCTION_IN_PCR'                        : hash35,
        'ERR_USE_OF_UNDEFINED_VAR'                          : hash36,
        'ERR_USE_OF_UNSET_FLAG'                             : hash37,
        'ERR_UNDEFINED_STRUCT'                              : hash38,
        'ERR_UNDEFINED_UNION'                               : hash39,
        'ERR_UNEXPECTED_VOID'                               : hash40,
        }

    # ERR_RETURN_IS_MISSING                => sub { my ($filename, $line, $function) = @_ ;
    # push  @_error_message,
    # _error_message($filename, $line, ("'return' statement is missing at the end of function '" . $function . "'.\n")) } ,
    # ERR_MAIN_FUNC_RETURNS_VALUE        => sub { my ($filename, $line, $function) = @_ ;
    # push  @_error_message,
    # _error_message($filename, $line, ("'main' function should return no value.\n")) } ,
    # ERR_MAIN_FUNC_HAS_ARGS        => sub { my ($filename, $line, $function) = @_ ;
    # push  @_error_message,
    # _error_message($filename, $line, ("'main' function should have no arguments.\n")) } ,

    @staticmethod
    def error_message(err_type, *args) :
        return CmmError._error_message[err_type](*args)

    @staticmethod
    def there_are_errors() :
        return len(CmmError._err_msg_list)

    @staticmethod
    def prnt() :
        for x in CmmError._err_msg_list :
            print x

        CmmError._err_msg_list = []
