import re
import CmmError

class CmmEval(object) :
    alu = {
	'||': lambda fst, sec: fst or sec,
	'&&': lambda fst, sec: fst and sec,
	'|'	: lambda fst, sec: fst |  sec,
	'^'	: lambda fst, sec: fst ^  sec,
	'&'	: lambda fst, sec: fst &  sec,
	'==': lambda fst, sec: fst == sec,
	'!=': lambda fst, sec: fst != sec,
	'>>': lambda fst, sec: fst >> sec,
	'<<': lambda fst, sec: fst * (2 ** sec),
	'>=': lambda fst, sec: fst >= sec,
	'>'	: lambda fst, sec: fst >  sec,
	'<=': lambda fst, sec: fst <= sec,
	'<'	: lambda fst, sec: fst <  sec,
	'+'	: lambda fst, sec: fst +  sec,
	'-'	: lambda fst, sec: fst -  sec,
	'U+': lambda fst     :   fst,
	'U-': lambda fst     : - fst,
	'~'	: lambda fst     : ~ fst,
	'!'	: lambda fst     : not fst,
    }

    p_unary_operator	= '^(\+\+PRE)|(\-\-PRE)|(U\+)|(U\-)|(~)|(!)|(\+\+POST)|(\-\-POST)$'
    p_binary_operator	= '^(\|\|)|(&&)|(\|)|(\^)|(&)|(==)|(!=)|(>>)|(<<)|(>=)|(>)|(<=)|(<)|([+-])$'

    filename = ''
    line = 0
    expr = []

    def __init__(self, mode) :
        self.mode = mode

    def _ev(self) :
        frst = CmmEval.expr.pop(0)

        if re.match(CmmEval.p_unary_operator, frst) :
            opA = self._ev()

            return opA if CmmError.there_are_errors() else CmmEval.alu[frst](opA)
        elif re.match(CmmEval.p_binary_operator, frst) :
            opA = self._ev()
            opB = self._ev()

            return opA if CmmError.there_are_errors() else CmmEval.alu[frst](opA, opB)
        else :
            if self.mode == 'tokens_are_constants_only' :
                if not (hasattr(frst, is_a_constant) and frst.is_a_constant()) :
                    CmmError.error_message('ERR_UNEXPECTED_NOT_CONST', CmmEval.filename, CmmEval.line)

                return frst
            else :
                return frst

    def evaluate(self, *args) :
        [CmmEval.expr, CmmEval.filename, CmmEval.line] = args

        # my @caller = () ;
        # for (0 .. 6) {
        # @caller = caller $_ ;
        # print "@caller\n" ;
        # }
        # print "evaluate @expr\n" ;

        return self._ev()
