class CmmExtInstruction(CmmInstruction) :
    def hash0(self) :
        opC = self.body[1]
        opA = self.body[2]
        opB = self.body[3]
        opC = opC.get_reg()
        opA = opA.get_reg()
        opB = opB.get_reg()
        my (opC_1, opC_0) = opC.splt_into_2()
        lsb = opB.get_lsb()
        msb = opB.get_msb()

        opB_1 = opB.get_32(1)
        opB_0 = opB.get_32(2)
        [
            CmmBinAsInstruction([ 'shri', opC_0, opB_0, 31 - (lsb & 0x1f) ]) ,
            CmmBinAsInstruction([ 'shli', opC_1, opB_1, lsb & 0x1f ]) ,
            CmmBinAsInstruction([ 'or', opC_0, opC_0, opC_1 ]) ,
            CmmBinAsInstruction([ 'shli', opC_1, opB_2, msb & 0x1f ]) ,
            CmmBinAsInstruction([ 'shri', opC_1, opC_1, 31 - (lsb & 0x1f) ]) ,
            CmmBinAsInstruction([ 'shri', opA, opB_1, 31 - (lsb & 0x1f) ]) ,
            CmmBinAsInstruction([ 'or', opC_1, opC_1, opA ]) ,
            ]
            
    def hash1(self) :
        opC = self.body[1]
        opA = self.body[2]
        opB = self.body[3]
        opC = opC.get_reg()
        opA = opA.get_reg()
        opB = opB.get_reg()
        my (opC_1, opC_0) = opC.splt_into_2()
        lsb = opB.get_lsb()
        msb = opB.get_msb()

        [
            CmmBinAsInstruction([ 'shri', opC_0, opB_0, 31 - (lsb & 0x1f) ]) ,
            CmmBinAsInstruction([ 'shli', opC_1, opB_1, msb & 0x1f ]) ,
            CmmBinAsInstruction([ 'shri', opC_1, opC_1, 31 - (lsb & 0x1f) ]) ,
            CmmBinAsInstruction([ 'or', opC_0, opC_0, opC_1 ]) ,
            ]
            
    def hash2(self) :
        opC = self.body[1]
        opA = self.body[2]
        opB = self.body[3]
        opC = opC.get_reg()
        opA = opA.get_reg()
        opB = opB.get_reg()
        my (opC_1, opC_0) = opC.splt_into_2()

        [
            CmmBinAsInstruction([ 'shri', opC_0, opB_0, 31 - (lsb & 0x1f) ]) ,
            CmmBinAsInstruction([ 'shli', opC_1, opB_1, msb & 0x1f ]) ,
            CmmBinAsInstruction([ 'shri', opC_1, opC_1, 31 - (lsb & 0x1f) ]) ,
            CmmBinAsInstruction([ 'or', opC_0, opC_0, opC_1 ]) ,
            ]
            
    def hash3(self) :
        opC = self.body[1]
        opA = self.body[2]
        opB = self.body[3]
        opC = opC.get_reg()
        opA = opA.get_reg()
        opB = opB.get_reg()
        my (opC_1, opC_0) = opC.splt_into_2()

        [
            CmmBinAsInstruction([ 'shri', opC_0, opB_0, 31 - (lsb & 0x1f) ]) ,
            CmmBinAsInstruction([ 'shli', opC_1, opB_1, msb & 0x1f ]) ,
            CmmBinAsInstruction([ 'shri', opC_1, opC_1, 31 - (lsb & 0x1f) ]) ,
            CmmBinAsInstruction([ 'or', opC_0, opC_0, opC_1 ]) ,
            ]
            
    def compute_left(self) :
        return (self.body[1])

    def fix_64_bit_arithmetic(self) :
        return []

    def fix_size_operand
{
}

{
my %fix_64_bit_ar = {
ext_64_64        => \&hash0,

ext_64_32        => \&hash1,

ext_64_16        => \&hash2,

ext_64_8        => \&hash3,

$ext{32}{32} =
$ext{32}{16} =
$ext{32}{8} =        sub
# Assumptions :
        # opA size == 32
        # if crosses 32 boundary get_reg returns 2 x 32 bit regs with no regards to the arg
        # crosses_32_bit_boundary works the same for tr and rf(selfbig, small, self, *args) :
        opC = self.body[1]
        opA = self.body[2]
        opB = self.body[3]

        opC = opC.get_reg()
        opA = opA.get_reg()
        opB = opB.get_reg(32)

        lsb = opB.get_lsb()
        msb = opB.get_msb()

        if (opC.is_a_rf_reg()) :
        else :
            mask = big - 1

            if (opB.crosses_32_bit_border()) :
                my (opB_1, opB_0) = opB.splt_into_2()

                [
                    CmmBinAsInstruction([ 'shri', opC, opB_0, mask - (lsb & mask) ; ]) ,
                CmmBinAsInstruction([ 'shli', opA, opB_1, msb & mask ]) ,
                    CmmBinAsInstruction([ 'shri', opA, opA, mask - ((lsb & mask) + (msb & mask)) ]) ,
                    CmmBinAsInstruction([ 'or', opC, opC, opA ]) ,
                    ]
            else :
                [
                    CmmBinAsInstruction([ 'shli', opC, opB, msb & mask ]) ,
                    CmmBinAsInstruction([ 'shri', opC, opC, mask - ((lsb & mask) + (msb & mask)) ]) ,
                    ]

    def fix_64_bit_ar(self) :
        op = self.body[0]
        opB = self.body[3]

        if (opB.is_nonalligned()) :
            asm = fix_64_bit_ar[op](self)
        else :
            opC = self.body[1]
            opB = self.body[3]
                                                small = opB.get_size()
            big = opC.get_size()
                                    instr

            opC = opC.get_reg()
            opB = opB.get_reg()

            if (opC.is_a_rf_reg()) :
                i = big ; i > small ; i >>= 1
                for my lv i : # one iteration at least is garanteed
                    (opC_1, opC_0) = opC.splt_into_2()
                    zero = CmmSR('zero', CmmType('u', i >> 1))
                    unshift instr, CmmBinAsInstruction([ 'subb', opC_1, zero, zero ])
                    opC = opC_0

                null = CmmSR('null', CmmType('u', i))
                unshift instr, CmmBinAsInstruction([ 'add', null, opC_0, opC_0 ])
                unshift instr, CmmAssgnInstruction([ 'move', opC_0, opB ])
            else :
                if (opB.is_a_rf_reg()) :
                    case_reg = opB.get_8(0)
                    mask = CmmConst(7)
                    shift = CmmConst(5)
                else :
                    case_reg = opB
                    mask = CmmConst(1 << (small - 1))
                    shift = CmmConst(small - 3)

                big == 64
                if big :
                    zero = CmmSR('null', CmmType('u', 32))
                    one = CmmSR('null', CmmType('u', 32))

                    (opC_1, opC_0) = opC.splt_into_2()

                    instr = (
                        CmmCaseInstruction([ 'case', case_reg, mask, shift, CmmConst(0) ]) ,
                        CmmAssgnInstruction([ 'move', opC_0, opB ]) ,
                        CmmAssgnInstruction([ 'move', opC_1, zero ]) ,
                        CmmBinAsInstruction([ 'adi', CmmSR('pc'), CmmSR('pc'), 6 ]) ,
                        CmmBinAsInstruction([ 'adi', CmmSR('pc'), CmmSR('pc'), 5 ]) ,
                        CmmBinAsInstruction([ 'and', opC_0, one, opB ]) ,
                        CmmAssgnInstruction([ 'move', opC_1, one ]) ,
                        CmmBinAsInstruction([ 'adi', CmmSR('pc'), CmmSR('pc'), 2 ]) ,
                        CmmBinAsInstruction([ 'adi', CmmSR('pc'), CmmSR('pc'), 1 ]) ,
                        )
                else :
                    shift --

                    zero = CmmSR('null', CmmType('u', big))
                    one = CmmSR('null', CmmType('u', big))

                    instr = (
                        CmmCaseInstruction([ 'case', case_reg, mask, shift, CmmConst(0) ]) ,
                        CmmBinAsInstruction([ 'or', opC, zero, opB ]) ,
                        CmmBinAsInstruction([ 'adi', CmmSR('pc'), CmmSR('pc'), 3 ]) ,
                        CmmBinAsInstruction([ 'and', opC, one, opB ]) ,
                        CmmBinAsInstruction([ 'adi', CmmSR('pc'), CmmSR('pc'), 1 ]) ,
                        )

            return [ instr ]
