from CmmInstruction import CmmInstruction

class CmmFCallInstruction(CmmInstruction) :
    def is_function_call_instruction(self) :
        return 1

    def get_function_call_number(self) :
        return self._function_call_number

    def get_function_call_arguments(self) :
        return self._function_call_arguments

    def get_function_name(self) :
        return self.body[0]

    def add_io_assignment(self, instr) :
        # print ("add_io_assignment " . $instr . "\n") ;
        # print "YYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYY\n" ;
        instr.set_function_call(self)
        self._io_assignment += [instr]

    def get_io_assignment(self) :
        return self._io_assignment

    def update_io_assignment(self, frm, to) :
        for lv in range(len(self._io_assignment)) :
            if (self._io_assignment[lv] == frm) :
                self._io_assignment[lv] = to
                break

    def customize(self) :
        return [ self ]
