import re
from CmmSpecVar import CmmSpecVar
from CmmValueLattice import CmmValueLattice

class CmmInstruction(object) :
    def __init__(self, body = None, function_call_number = None, function_call_arguments = None) :
        # type                                =>        $type ,
        print('XOXO' * 10)
        self.body = body or []
        print('XAXA' * 10)
        self._labels = []
        self.father = {}
        self.child = {}
        print('XAXA' * 10)
        self._next = None
        self._color = 0
        print('XAXA' * 10)
        self._coord = 0
        print('INIT' * 10)
        self._function_call_number = function_call_number or 0
        self._function_call_arguments = function_call_arguments or []
        print('INIT' * 10)
        self._io_assignment = []
        self._origin_web = -1
        self._bb = None
        self._dead = 0
        self._real_use = 1
        self._def = None
        print('INIT' * 10)
        self._use = []
        self._PHI = None
        self._insert = 0
        self._jump_data = []
        self._fc_instr = None
        print('INIT' * 10)
        self._left_side_effect = {
                                    'G'    :    CmmSpecVar('', 'G') ,
                                    'L'    :    CmmSpecVar('', 'L') ,
                                    'E'    :    CmmSpecVar('', 'E') ,
                                    'C'    :    CmmSpecVar('', 'C') ,
                                 }
        print('INIT' * 10)
        self._right_side_effect = {
                                    'G'    :    CmmSpecVar('', 'G') ,
                                    'L'    :    CmmSpecVar('', 'L') ,
                                    'E'    :    CmmSpecVar('', 'E') ,
                                    'C'    :    CmmSpecVar('', 'C') ,
                                 }

        print('INIT' * 10)
        self._value = CmmValueLattice('no_data')
        self._final_asm_form = []

        print('INIT' * 10)
        self.init()

    def new(self, copy_number = None) :
        c = self.cwl(copy_number)
        c._labels = [ x.new(copy_number) for x in self._labels  ]

        return c

    def cwl(self, copy_number = None) :
        key = None
        value = None

        c = type(self)()

        print ("ccc 0 " + str(self) + " " + str(self.body) + "\n")

        c.body = [ (x.new() if (x.is_a_var() and x.is_a_return_var()) else x.new(copy_number))
                   if (not (type(x) is int or type(x) is str) and (x.is_a_var() or x.is_a_label()))
                   else x
                   for x in self.body ]

        print ("ccc 1 " + str(c) + " " + str(c.body) + "\n")
        c._labels = []

        print ("ccc 1 " + str(c) + " " + str(c.body) + "\n")
        if self._jump_data :
            c._jump_data = [ x.new(copy_number) if (not (type(x) is int or type(x) is str) and (x.is_a_var() or x.is_a_label()))
                             else x
                             for x in self._jump_data ]

        print ("ccc 2 " + str(c) + " " + str(c.body) + "\n")
        c._io_assignment = self._io_assignment[:]
        c._function_call_number = self._function_call_number
        c._function_call_arguments = [x.new(copy_number) for x in self._function_call_arguments ]
        print ("ccc 3 " + str(c) + " " + str(c.body) + "\n")

        return c

    case_counter = 0
    default_counter = 0
    goto_counter = 0
    next_counter = 0
    yes_counter = 0
    no_counter = 0
    tmp_counter = 0

    @classmethod
    def get_case_edge(cls, case_value) :
        e =  case_value + '_' + str(cls.case_counter)
        cls.case_counter += 1
        return e

    @classmethod
    def get_default_edge(cls) :
        e = 'default_' + str(cls.default_counter)
        cls.default_counter += 1
        return e

    @classmethod
    def _get_goto_edge(cls) :
        e = 'goto_' + str(cls.goto_counter)
        cls.goto_counter += 1
        return e

    @classmethod
    def _get_next_edge(cls) :
        e = 'next_' + str(cls.next_counter)
        cls.next_counter += 1
        return e

    @classmethod
    def _get_yes_edge(cls) :
        e = 'yes_' + str(cls.yes_counter)
        cls.yes_counter += 1
        return e

    @classmethod
    def _get_no_edge(cls) :
        e = 'no_' + str(cls.no_counter)
        cls.no_counter += 1
        return e

    @classmethod
    def concat(cls, fst, sec, edge) :
        # for (0 .. 7) {
        # my @caller = caller($_) ;
        # print "caller is @caller\n" ;
        # }
        if re.match("next|yes", edge) :
            fst._next = sec

        fst.child[edge] = sec
        sec.father[edge] = fst

        return [fst, sec]

    @classmethod
    def concat_goto(cls, *args) :
        tmp = args + (cls._get_goto_edge(),)
        return cls.concat(*tmp)        

    @classmethod
    def concat_next(cls, *args) :
        tmp = args + (cls._get_next_edge(),)
        return cls.concat(*tmp)        

    @classmethod
    def concat_yes(cls, *args) :
        tmp = args + (cls._get_yes_edge(),)
        return cls.concat(*tmp)        

    @classmethod
    def concat_no(cls, *args) :
        tmp = args + (cls._get_no_edge(),)
        return cls.concat(*tmp)        

    @classmethod
    def concat_with_appropriate_edge(cls, father, child, edge) :
        if re.match("next", edge) :
            return cls.concat_next(father, child)
        elif re.match("yes", edge) :
            return cls.concat_yes(father, child)
        elif re.match("no", edge) :
            return cls.concat_no(father, child)
        elif re.match("goto", edge) :
            return cls.concat_goto(father, child)
        elif re.match("default", edge) :
            return cls.concat_default(father, child)
        else :
            m = re.match("(\d+)", edge)
            if m :
                n = m.group(1)
                return cls.concat(father, child, self.get_case_edge(n))

    def init(self) :
        pass

    def set_labels(self, labels) :
        self._labels = labels

    def get_labels(self) :
        return self._labels

    def delete_labels(self) :
        self._labels = []

    @staticmethod
    def transfer_labels(frm, to) :
        to._labels = frm._labels
        frm._labels = []

    def add_label(self, label) :
        self._labels += [label]

    def get_label(self) :
        return self._labels[0] if self._labels else None

    def is_labeled_with(self, label) :
        return filter(lambda x: x == label, self._labels)

    def delete_label(self, label) :
        i = 0

        for lv in self._labels :
            if (lv == label) :
                break
            else :
                i = i + 1

        self._labels[i : i + 1] = []

    def substitute_operand(self, orig, new) :
        i = None

        for i in range(0, len(self.body)) :
            if (self.body[i] == orig) :
                self.body[i] = new
                return

    def set_next(self, next) :
        self._next = next

    def get_next(self) :
        return self._next

    def get_first_operand(self) :
        return self.body[1]

    def is_placeholder(self) :
        return 0

    def is_null(self) :
        return 0

    def transform(self, clss, body) :
        # print ("old class " . @{[ref($self)]} . ", new class " . $self . ", old body " . @{$self->{body}} . ", new body " . @{$body} . "\n") ;

        # $self->{type} = $type ;
        self.body = body
        self.__class__ = clss

    def set_coord(self, coord) :
        self._coord = coord

    def get_coord(self) :
        return self._coord

    def set_color(self, color) :
        self._color = color

    def get_color(self) :
        return self._color

    def get_child(self, name) :
        return self.child[name]

    def get_children(self) :
        return self.child.values()

    def get_children_names(self) :
        return self.child.keys()

    def get_number_of_children(self) :
        return len(self.child.keys())

    def get_parent(self, name) :
        return self.father[name]

    def get_parents(self) :
        return self.father.values()

    def get_parents_names(self) :
        return self.father.keys()

    def transfer_parents(self, frm, to) :
        to.father = frm.father

        for lv in to.father :
            to.father[lv].child[lv] = to

        frm.father = {}

    def replace_in_instruction(self, to_replace, by) :
        # my $to_replace_id = $to_replace->get_id() ;

        for lv in range(len(self.body)) :
            if (self.body[lv] == to_replace) :
                print ("replace_in_instruction |" + str(self.body[lv]) + "| vs |" + str(to_replace) + "|\n")
                self.body[lv] = by
            # $self->{body}[$lv] = $by if ($self->{body}[$lv] eq $to_replace) ;

    def substitute(self, instr, frst = None, last = None) :
        if frst :
            if not last : last = frst
            print ("substitute " + str(instr.body) + " by [" + str(frst.body) + " ,,, " + str(last.body) + str("]\n"))

            for lv in instr.father :
                CmmInstruction.concat(instr.father[lv], frst, lv)

            instr.father = {}

            for lv in instr.child :
                CmmInstruction.concat(last, instr.child[lv], lv)

            instr.child = {}
        else :
            # this 'else' can only happen if this function called from '_simplify_expressions'
            # in this case $self has only one child
            # my ($child) = values %{$instr->{child}} ;

            # if ($child) {
            # for (keys %{$instr->{father}}) {
            # CmmInstruction->concat($instr->{father}{$_}, $child, $_) ;
            # }
            # }

            child = None
            father = None

            for lv in instr.child :
                child = instr.child[lv]
                del child.father[lv]

                for lv in instr.father :
                    father = instr.father[lv]
                    CmmInstruction.concat(father, child, lv)

            instr.child = {}
            instr.father = {}

            return child

    def set_body(self, body) :
        self.body = body

    def get_body(self) :
        return self.body

    def get_first_token(self) :
        return self.body[0]

    def get_vars(self) :
        return filter(lambda x: hasattr(x, 'is_a_var') and x.is_a_var(), self.get_body())

    def process_condition(self) :
        if (len(self.body) == 1) :
            self.transform(CmmCmpInstruction, [ '!=', self.body[0], CmmConst(0) ])
            # $self->{body} = [ '!=', @{$self->{body}}, CmmConst->new(0) ] ;

    @staticmethod
    def _jump_if_failure(comparison_op) :
        if (comparison_op == '<') :
            return (0x1e, 0)
        elif (comparison_op == '>') :
            return (0x1f, 0)
        elif (comparison_op == '<=') :
            return (0x1f, 1)
        elif (comparison_op == '>=') :
            return (0x1e, 1)
        elif (comparison_op == '==') :
            return (0x1d, 0)
        elif (comparison_op == '!=') :
            return (0x1d, 1)
        # elsif ($comparison_op eq '!') {
        # (0x1d, 0) ;
        # }
        else : # no comparison operand
            return (0x1d, 1)

    @staticmethod
    def _jump_if_success(comparison_op) :
        if (comparison_op == '<') :
            return (0x1e, 1)
        elif (comparison_op == '>') :
            return (0x1f, 1)
        elif (comparison_op == '<=') :
            return (0x1f, 0)
        elif (comparison_op == '>=') :
            return (0x1e, 0)
        elif (comparison_op == '==') :
            return (0x1d, 1)
        elif (comparison_op == '!=') :
            return (0x1d, 0)
        # elsif ($comparison_op eq '!') {
        # (0x1d, 1) ;
        # }
        else : # no comparison operand
            return (0x1d, 0)

    def add_jump_after_comparison(self, jump_condition, label) :
        cond_last = None
        fst = self.get_first_token()
        (bit, bit_value) = CmmInstruction._jump_if_failure(fst) if (jump_condition == 'failure') else CmmInstruction._jump_if_success(fst)

        self.set_jump_data([ CmmSR('pc'), label, CmmConst(bit), CmmConst(bit_value) ])

        print ("add_jump_after_comparison " + str(self) + " " + str(self._jump_data) + "\n")

        (_, cond_last) = CmmInstruction.concat_next(self, CmmGotoInstruction(['btj',
                                                                                CmmSR('pc'),
                                                                                label,
                                                                                CmmConst(bit) ,
                                                                                CmmConst(bit_value)
                                                                                ]))

        return cond_last

    def set_jump_data(self, jump_data) :
        print ("get_jump_data " + str(self) + " " + str(self.body) + "\n")
        self._jump_data = jump_data

    def get_jump_data(self) :
        print ("get_jump_data " + str(self) + " " + str(self.body) + "\n")
        return self._jump_data

    def get_args(self) :
        return filter(lambda x: not (type(x) is int or type(x) is str), self.get_body())

    def compute_left(self) :
        return []

    def get_left_basic(self) :
        tmp = self.compute_left()
        print ("get_left_basic 1 " + str([ (x, type(x)) for x in tmp]) + "\n")
        tmp = filter(lambda x: x.is_a_var() or x.is_a_rf_reg() or x.is_a_tr_reg() or x.is_a_mp_reg(), self.compute_left())
        print ("get_left_basic 2 " + str([ (x, type(x)) for x in tmp]) + "\n")
        return filter(lambda x: x.is_a_var() or x.is_a_rf_reg() or x.is_a_tr_reg() or x.is_a_mp_reg(), self.compute_left())

    def compute_operands(self) :
        operands = filter(lambda x: x.is_a_var() or x.is_a_rf_reg() or x.is_a_tr_reg() or x.is_a_mp_reg(), self.get_args())

        print "O1 " + operands + "\n"
        if (self.get_left_basic()) : operands.pop(0)

        print "O2 " + operands + "\n"
        return operands

    def get_operands_basic(self) :
        return self.compute_operands()

    def get_left_ext(self) :
        return [self.get_left_side_effect(), self.get_left_basic()]

    def get_dest_basic(self) :
        return self.compute_left()

    def get_dest_ext(self) :
        return [self.get_left_side_effect(), self.get_dest_basic()]

    def get_operands_ext(self) :
        return [self.get_right_side_effect(), self.get_operands_basic()]

    def get_left(self) :
        left = filter(lambda x: x.is_a_var() or x.is_a_rf_reg() or x.is_a_tr_reg() or x.is_a_mp_reg(), self.compute_left())

        return [ (x.splt()) if (x.is_a_rf_reg() or x.is_a_tr_reg()) else (x)  for x in left]

    def get_operands(self) :
        operands = filter(lambda x: x.is_a_var() or x.is_a_rf_reg() or x.is_a_tr_reg() or x.is_a_mp_reg(), self.compute_operands())

        return [ (x.splt()) if (x.is_a_rf_reg() or x.is_a_tr_reg()) else (x)  for x in operands]

    def set_origin_web(self, origin_web) :
        self._origin_web = origin_web

    def get_origin_web(self) :
        return self._origin_web

    def set_def(self, df) :
        self._def = df
        df.set_use(self)

    def get_def(self) :
        return self._def

    def set_use(self, use) :
        self._use += [use]

    def get_use(self) :
        return self._use

    def set_PHI(self, PHI) :
        self._PHI = PHI

    def get_PHI(self) :
        return self._PHI

    def is_dummy(self) :
        return 0

    def is_function_call_instruction(self) :
        return 0

    def is_set_E_instruction(self) :
        return 0

    def is_a_huge_number_assignment(self) :
        return 0

    def is_a_conditional_jump(self) :
        return 0

    def is_a_zero_comparison(self) :
        return 0

    def is_orig_asm_instruction(self) :
        return 0

    def condition_was_changed(self) :
        return 0

    def set_dead(self) :
        self._dead = 1

    def set_alive(self) :
        self._dead = 0

    def is_dead(self) :
        return self._dead

    def set_real_use(self) :
        self._real_use = 1

    def has_real_use(self) :
        return self._real_use

    def set_insert(self) :
        self._insert = 1

    def get_insert(self) :
        return self._insert

    def check_if_it_has_rf_tr_mp_regs_as_an_arg(self) :
        # my @op = $self->get_args() ;
        self._has_no_important_regs = (0) if (filter(lambda x: x.is_a_rf_reg() or x.is_a_tr_reg() or x.is_a_mp_reg(), self.get_args())) else (1)
        # print ("check_if_it_has_regs_as_an_arg !" . @{$self->{body}} . "! >" . @op . "< " . $self->{_has_no_important_regs} . "\n") ;

    def has_no_rf_tr_mp_reg_as_an_arg(self) :
        return self._has_no_important_regs

    def process_assignment_and_unary_operators(self) :
        body = self.body
        i = None
        j = None
        op = None
        left = None

        body = filter(lambda x: not (type(x) is str and x == 'U+'), body)

        i = 0
        while i < len(body) :
            if type(body[i]) is str and re.match("([-+&^|]|>>|<<)=$", body[i]) :
                op = 1
                left = body[i + 1]
                # bug Check if '$left' can be a pointer to an array !
                body[i, i + 2] = ['=', left, op, left[:] if type(left) is list else left.new()]
                i = i + 3
            elif type(body[i]) is str :
                if body[i] == 'U-' :
                    j = i + 1
                    while type(body[j]) is str and body[j] == 'U-' :
                        j = j + 1
    
                    if ((j - i) & 1) :
                        size = self.get_normalized_size(body[j].get_size())
                        body[i : j] = ['-', CmmSR('zero', CmmType('u', size))]
                        i = i + 1
                    else :
                        body[i : j] = []
                        i = i - 1
                elif body[i] == '~' :
                    j = i + 1
                    while type(body[j]) is str and body[j] == '~' :
                        j = j + 1
    
                    if ((j - i) & 1) :
                        size = self.get_normalized_size(body[j].get_size())
                        body[i : j] = ['^', CmmSR('one', CmmType('u', size))]
                        i = i + 1
                    else :
                        body[i : j] = []
                        i = i - 1
                elif body[i] == '!' :
                    j = i + 1
                    while type(body[j]) is str and body[j] == '!' :
                        j = j + 1
    
                    if ((j - i) & 1) :
                        body[i : j] = ['==', CmmConst(0)]
                        i = i + 1
                    else :
                        body[i : j] = []
                        i = i - 1

            i = i + 1

    def fix_64_bit_arithmetic(self) :
        return []

    _size = {
                64 : {
                        64 : {
                                '_' : 'LL_',
                             }
                     },
                32 : {
                        32 : {
                                32  : 'DDD',
                                16  : 'DDW',
                                8   : 'DDB',
                                '_' : 'DD_',
                             },
                        '_' : {
                                '_' : 'D__',
                             }
                     },
                16 : {
                        16 : {
                                16  : 'WWW',
                                8   : 'WWB',
                                '_' : 'WW_',
                             },
                        '_' : {
                                '_' : 'W__',
                             }
                     },
                8 : {
                        8  : {
                                8   : 'BBB',
                                '_' : 'BB_',
                             },
                        '_' : {
                                '_' : 'B__',
                             }
                     },
            }

    def get_asm_operand_size(self, opC_size, opA_size, opB_size) :
        return CmmInstruction._size[opC_size][opA_size][opB_size]

    def fix_size_operand(self) :
        pass

    def customize_in_accordance_with_sizes(self) :
        return [ self ]

    def fix_shift_operation(self) :
        return [ self ]

    def fix_assignment_with_small_right_side_0(self) :
        return [ self ]
            ##### ([ self ], [])

    def fix_instr_with_opC_smaller_than_opA(self) :
        return [ self ]
        ##### ([ shift ], [])  ;

    def fix_instr_with_opA_smaller_than_opB(self) :
        return [ self ]
        ##### ([ shift ], [])  ;

    def process_64_bit_spec_reg(self) :
        print ("ccc 5.5 " + str(self) + " " + str(self.body) + "\n")
        return [ self ]

    def put_constant_at_opB(self) :
        return [ self ]
        ##### ([ shift ], []) ;

    def fix_memory_usage_1(self) :
        return [ self ]
        ##### ([ shift ], []) ;

    def fix_memory_usage_0(self) :
        return [ self ]
        ##### ([ shift ], []) ;

    def fix_use(self) :
        return [ self ]

    def fix_bitfield_def(self) :
        return [ self ]

    # my %h = {} ;

    @staticmethod
    def map_fix_memory_usage_0(instr) :
        code = instr.fix_memory_usage_0()
        CmmInstruction.transfer_labels(instr, code[0]) ;
        return code

    @staticmethod
    def map_fix_memory_usage_1(instr) :
        print('A' * 80)
        print(instr)
        code = instr.fix_memory_usage_1()
        print('A' * 80)
        CmmInstruction.transfer_labels(instr, code[0]) ;
        print('B' * 80)
        return code

    @staticmethod
    def map_put_constant_at_opB(instr) :
        code = instr.put_constant_at_opB()
        CmmInstruction.transfer_labels(instr, code[0]) ;
        return code

    @staticmethod
    def map_process_64_bit_spec_reg(instr) :
        print ("ccc 5 " + str(instr) + " " + str(instr.body) + "\n")
        code = instr.process_64_bit_spec_reg()
        print ("ccc 5 " + str(instr) + " " + str(instr.body) + "\n")
        CmmInstruction.transfer_labels(instr, code[0]) ;
        return code

    @staticmethod
    def map_fix_use(instr) :
        code = instr.fix_use()
        CmmInstruction.transfer_labels(instr, code[0]) ;
        return code

    @staticmethod
    def map_customize_in_accordance_with_sizes(instr) :
        code = instr.customize_in_accordance_with_sizes()
        CmmInstruction.transfer_labels(instr, code[0]) ;
        return code

    def customize(self, tmp_instr) :
        simple_expr = [ self ]

        new_code = []

        for instr in simple_expr:
            new_code.extend(CmmInstruction.map_fix_memory_usage_0(instr))

        simple_expr = new_code
        new_code = []

        print('?' * 80)
        for instr in simple_expr:
            new_code.extend(CmmInstruction.map_fix_memory_usage_1(instr))

        print('?' * 80)
        simple_expr = new_code
        new_code = []

        for instr in simple_expr:
            new_code.extend(CmmInstruction.map_put_constant_at_opB(instr))

        print('?' * 80)
        simple_expr = new_code
        new_code = []

        print('+' * 80)
        for instr in simple_expr:
            print ("ccc 4 " + str(instr) + " " + str(instr.body) + "\n")
            tmp = CmmInstruction.map_process_64_bit_spec_reg(instr)
            print ("ccc 5 " + str(instr) + " " + str(instr.body) + "\n")
            new_code.extend(tmp)
            # new_code.extend(CmmInstruction.map_process_64_bit_spec_reg(instr))

        simple_expr = new_code
        new_code = []

        print('!' * 80)
        for instr in simple_expr:
            new_code.extend(CmmInstruction.map_fix_use(instr))

        simple_expr = new_code
        new_code = []

        print('!' * 80)
        for instr in simple_expr:
            new_code.extend(CmmInstruction.map_customize_in_accordance_with_sizes(instr))

        i = 0
        print('!' * 80)
        while i < len(new_code) - 1:
            CmmInstruction.concat_next(new_code[i], new_code[i + 1])
            i = i + 1

        print('-' * 80)
        return new_code

    def set_function_call(self, fc_instr) :
        self._fc_instr = fc_instr

    def update_function_call(self, orig_instr) :
        if (orig_instr._fc_instr) :
            orig_instr._fc_instr.update_io_assignment(orig_instr, self)
            self._fc_instr = orig_instr._fc_instr

    def transform_to_pseudo_asm_form(self) :
        pass

    def set_instr_for_variables(self) :
        print ("set_instr_for_variables " + str(self.body) + "\n")

        for lv in self.get_left_side_effect() :
            lv.set_instr(self)

        for lv in self.get_right_side_effect() :
            lv.set_instr(self)

        for lv in self.body :
            t = type(lv)
            if (not (t is int or t is str) and lv.is_a_var()) :
                lv.set_instr(self)

    def set_bb(self, bb) :
        self._bb = bb

    def get_bb(self) :
        return self._bb

    def is_copy(self) :
        return 0

    def is_pcr(self) :
        return 0

    def is_cmd(self) :
        return 0

    def is_goto(self) :
        return 0

    def is_jsr(self) :
        return 0

    def is_move(self) :
        return 0

    def is_mviw(self) :
        return 0

    def is_mvib(self) :
        return 0

    def is_load(self) :
        return 0

    def is_store(self) :
        return 0

    def is_fake(self) :
        return 0

    def is_phi(self) :
        return 0

    def is_PHI(self) :
        return 0

    def delete_child(self, child_name) :
        del self.child[child_name]

    def delete_parent(self, father_name) :
        del self.father[father_name]

    def destroy(self) :
        for lv in self.get_left_side_effect() :
            lv.destroy_instr()
            lv.delete_ud_chain()

        for lv in self.get_right_side_effect() :
            lv.destroy_instr()
            lv.delete_du_chain()

        for lv in self.body :
            t = type(lv)
            if (not (t is int or t is str) and lv.is_a_var()) :
                lv.destroy_instr()
                lv.delete_ud_chain()
                lv.delete_du_chain()

        for lv in self.father :
            self.father[lv].delete_child(lv)
            del self.father[lv]

        for lv in self.child :
            self.child[lv].delete_parent(lv)
            del self.child[lv]

    def is_yes_edge(self, edge_label) :
        return re.match("yes_", edge_label)

    def is_no_edge(self, edge_label) :
        return re.match("no_", edge_label)

    def _get_flags_set(self) :
        return []

    def _get_flags_used(self) :
        return []

    def get_left_side_effect(self, *flags) :
        l = []
        tmp = [ self._left_side_effect[x]  for x in (flags or self._get_flags_set())]
        for lv in tmp:
            l.extend(lv)
        return l

    def get_right_side_effect(self, *flags) :
        l = []
        tmp = [ self._right_side_effect[x]  for x in (flags or self._get_flags_used())]
        for lv in tmp:
            l.extend(lv)
        return l

    def set_final_asm_form(self, final_asm_form) :
        self._final_asm_form = final_asm_form

    def get_final_asm_form(self) :
        return self._final_asm_form

    def set_value(self, value) :
        self._value = value

    def get_value(self) :
        return self._value

    def _set_G(self) :
        [flag] = self.get_left_side_effect('G')

        flag.set_value(CmmValueLattice('1'))

    def _reset_G(self) :
        [flag] = self.get_left_side_effect('G')

        flag.set_value(CmmValueLattice('0'))

    def _set_L(self) :
        [flag] = self.get_left_side_effect('L')

        flag.set_value(CmmValueLattice('1'))

    def _reset_L(self) :
        [flag] = self.get_left_side_effect('L')

        flag.set_value(CmmValueLattice('0'))

    def _set_E(self) :
        [flag] = self.get_left_side_effect('E')

        flag.set_value(CmmValueLattice('1'))

    def _reset_E(self) :
        [flag] = self.get_left_side_effect('E')

        flag.set_value(CmmValueLattice('0'))

    def _set_C(self) :
        [flag] = self.get_left_side_effect('C')

        flag.set_value(CmmValueLattice('1'))

    def _reset_C(self) :
        [flag] = self.get_left_side_effect('C')

        flag.set_value(CmmValueLattice('0'))

    def evaluated_to_different_values(self) :
        return self._value.is_max()

    def evaluated_to_jump(self) :
        return self._value.is_ordinary_constant() and self._value.get_value()

    def evaluate(self) :
        pass

    def clean_up_right_side_defs(self) :
        for lv in self.get_right_side_effect() :
            lv.delete_du_chain()

        for lv in filter(lambda x: x.is_a_var(), self.get_operands()) :
            lv.delete_du_chain()

    # 0 below is put to shift the rest of elements one position to the right
    # to make get_normalized_size() logic simpler
    norm_size = [ 0 ] + [ 8 ] * 8 + [ 16 ] * 8 + [ 32 ] * 16 + [ 64 ] * 32

    def get_normalized_size(self, size) :
        return CmmInstruction.norm_size[size]
