import copy
from CmmSymbol import CmmSymbol
from CmmType import CmmType

class CmmLabel(CmmSymbol) :
    def __init__(self, function, name = None) :
        self._function = function
        self._cc = 0L
        self._copy = {}

        s = name or ''
        self._set_name(s)
        # self._set_name((name) if (name) else (''))
        self.set_type(CmmType('u', 16))

        self._set_id()

    def new(self, copy_number = None) :
        if (copy_number and self._copy.has_key(copy_number)) :
            return self._copy[copy_number]
        else :
            c = copy.deepcopy(self)

            if (copy_number) :
                c._set_cc(copy_number)
            else :
                copy_number = c._cc

            self._copy[copy_number] = c

        c._set_id()

        return c

    def _init(self) :
        pass

    def is_a_label(self) :
        return 1

    def get_name(self) :
        return self._name

    def _set_cc(self, value) :
        self._cc = value

    def _set_name(self, name) :
        self._name = name + '_'

    def _set_id(self) :
        self._id = ((self._function + '__' + str(self._cc) + '__') if self._cc else ('')) + str(self._name)
        # $self->{_id} = $self->{_function} . '__' . $self->{_cc} . '__' . $self->{_name} ;

    def is_ifelse_label(self) :
        return 0

    def is_while_label(self) :
        return 0

    def is_for_label(self) :
        return 0

    def is_do_label(self) :
        return 0
