import copy
from CmmSymbol import CmmSymbol

class CmmMemRef(CmmSymbol) :
    def __init__(self, var, index_statement) :
        self._mem_address_var = var
        self._msb = None
        self._lsb = None
        self._statements_to_evaluate = [ index_statement ]
        # _copy                                =>        {} ,
        # _cc                                =>        0L ,


        self._set_id()
        self.set_type(CmmType('u', 64))

    def new(self, var, index_statement) :
        c = copy.deepcopy(self)
        c._set_id()
        return c

    def get_name(self) :
        return '#' * 11

    def is_a_mem_ref(self) :
        return 1

    def _set_id(self) :
        self._id = '#' * 7 + str(self._mem_address_var.get_id())

    def set_bit_range(self, msb_bit, lsb_bit, *statements) :
        self._msb = msb_bit
        self._lsb = lsb_bit
        self._statements_to_evaluate += statements

    def get_statements_to_evaluate(self) :
        if (len(self._statements_to_evaluate)) :
            print "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZz\n"
            print (self._statements_to_evaluate + "\n")
            print (self._statements_to_evaluate[0] + "\n")
            print (self._statements_to_evaluate[0]['flowchart'] + "\n")
            print (self._statements_to_evaluate[0]['flowchart']['start'] + "\n")
            print (self._statements_to_evaluate[0]['flowchart']['finish'] + "\n")
            print (self._statements_to_evaluate[0]['flowchart']['start']['body'] + "\n")
            print (self._statements_to_evaluate[0]['flowchart']['finish']['body'] + "\n")
            print "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZz\n"

        z = self._statements_to_evaluate[ : ]
        self._statements_to_evaluate[ : ] = []
        return z

    def get_mem_address_var(self) :
        return self._mem_address_var
