from CmmInstruction import CmmInstruction
from CmmValueLattice import CmmValueLattice

class CmmPhi(CmmInstruction) :
    def _init(self) :
        self._operand                 =        { }
        self._downsafe                =        1
        self._will_be_available       =        0
        self._can_be_available        =        1
        self._later                   =        0

    def compute_left(self) :
        return [self.body[1]]

    def set_phi_operand(self, key, value) :
        # $self->{_operand}{$key} = $value ;

        # push @{$self->{body}}, $value ;

        self._operand[key] = value

        self.body += [self._operand[key]]

    def delete_phi_operand(self, key) :
        op = self._operand[key]

        op.destroy_instr()

        self.body = filter(lambda x: x != op, self.body)

        del self._operand[key]

    def set_PHI_operand(self, key, value) :
        # $self->{_operand}{$key} = $value ;

        value.set_PHI(self)

        self._operand[key] = value

        self.body += [self._operand[key]]

    def is_downsafe(self) :
        return self._downsafe

    def reset_downsafe(self) :
        self._downsafe = 0

    def can_be_available(self) :
        return self._can_be_available

    def reset_can_be_available(self) :
        self._can_be_available = 0

    def set_later(self) :
        self._later = 1

    def reset_later(self) :
        self._later = 0

    def get_later(self) :
        return self._later

    def compute_will_be_available(self) :
        self._will_be_available = self._can_be_available & ~ self._later

    def will_be_available(self) :
        return self._will_be_available

    def is_phi(self) :
        return 1

    def is_PHI(self) :
        return 1

    def evaluated_to_ordinary_constant(self) :
        (left) = self.get_left()

        return left.get_value().is_ordinary_constant()

    def evaluate(self) :
        operands_values = [ (x) if (x.is_a_constant()) else (x.get_value())  for x in self.get_operands()]
        max = filter(lambda x: x.is_max(), operands_values)
        ord_cnst = filter(lambda x: x.is_ordinary_constant(), operands_values)

        if (len(max)) :
            for lv in self.get_left() :
                lv.set_value(CmmValueLattice('multiple_data'))
        elif (len(ord_cnst)) :
            tmp = filter(lambda x: x != ord_cnst[0], ord_cnst)
            if (len(tmp)) :
                for lv in self.get_left() :
                    lv.set_value(CmmValueLattice('multiple_data'))
            else :
                for lv in self.get_left() :
                    lv.set_value(ord_cnst[0].new())

    def customize(self) :
        return [ self ]
