import copy
from CmmSymbol import CmmSymbol
from CmmValueLattice import CmmValueLattice
from CmmMisc import CmmMisc
from CmmType import CmmType

class CmmReg(CmmSymbol) :
    reg_size = {
        'nP7510'                                            : {
        'r0_0'                                              : 8 ,
        'r0_1'                                              : 8 ,
        'r0_2'                                              : 8 ,
        'r0_3'                                              : 8 ,
        'r0_4'                                              : 8 ,
        'r0_5'                                              : 8 ,
        'r0_6'                                              : 8 ,
        'r0_7'                                              : 8 ,
        'r1_0'                                              : 8 ,
        'r1_1'                                              : 8 ,
        'r1_2'                                              : 8 ,
        'r1_3'                                              : 8 ,
        'r1_4'                                              : 8 ,
        'r1_5'                                              : 8 ,
        'r1_6'                                              : 8 ,
        'r1_7'                                              : 8 ,
        'r2_0'                                              : 8 ,
        'r2_1'                                              : 8 ,
        'r2_2'                                              : 8 ,
        'r2_3'                                              : 8 ,
        'r2_4'                                              : 8 ,
        'r2_5'                                              : 8 ,
        'r2_6'                                              : 8 ,
        'r2_7'                                              : 8 ,
        'r3_0'                                              : 8 ,
        'r3_1'                                              : 8 ,
        'r3_2'                                              : 8 ,
        'r3_3'                                              : 8 ,
        'r3_4'                                              : 8 ,
        'r3_5'                                              : 8 ,
        'r3_6'                                              : 8 ,
        'r3_7'                                              : 8 ,
        'r4_0'                                              : 8 ,
        'r4_1'                                              : 8 ,
        'r4_2'                                              : 8 ,
        'r4_3'                                              : 8 ,
        'r4_4'                                              : 8 ,
        'r4_5'                                              : 8 ,
        'r4_6'                                              : 8 ,
        'r4_7'                                              : 8 ,
        'r5_0'                                              : 8 ,
        'r5_1'                                              : 8 ,
        'r5_2'                                              : 8 ,
        'r5_3'                                              : 8 ,
        'r5_4'                                              : 8 ,
        'r5_5'                                              : 8 ,
        'r5_6'                                              : 8 ,
        'r5_7'                                              : 8 ,
        'r6_0'                                              : 8 ,
        'r6_1'                                              : 8 ,
        'r6_2'                                              : 8 ,
        'r6_3'                                              : 8 ,
        'r6_4'                                              : 8 ,
        'r6_5'                                              : 8 ,
        'r6_6'                                              : 8 ,
        'r6_7'                                              : 8 ,
        'r7_0'                                              : 8 ,
        'r7_1'                                              : 8 ,
        'r7_2'                                              : 8 ,
        'r7_3'                                              : 8 ,
        'r7_4'                                              : 8 ,
        'r7_5'                                              : 8 ,
        'r7_6'                                              : 8 ,
        'r7_7'                                              : 8 ,
        'tr0'                                               : 32 ,
        'tr1'                                               : 32 ,
        'tr2'                                               : 32 ,
        'tr3'                                               : 32 ,
        'tr4'                                               : 32 ,
        'tr5'                                               : 32 ,
        'tr6'                                               : 32 ,
        'tr7'                                               : 32 ,
        'tr8'                                               : 32 ,
        'tr9'                                               : 32 ,
        'tr10'                                              : 32 ,
        'tr11'                                              : 32 ,
        'tr12'                                              : 32 ,
        'tr13'                                              : 32 ,
        'tr14'                                              : 32 ,
        'tr15'                                              : 32 ,
        'zero'                                              : 32 ,
        'one'                                               : 32 ,
        'pc'                                                : 32 ,
        'tn'                                                : 32 ,
        'trm_drt_mask'                                      : 32 ,
        'rstt'                                              : 32 ,
        'mp0'                                               : 32 ,
        'mp1'                                               : 32 ,
        'mp2'                                               : 32 ,
        'mp3'                                               : 32 ,
        'tstt'                                              : 32 ,
        'cmd'                                               : 64 ,
        'crb0'                                              : 32 ,
        'crb1'                                              : 32 ,
        'ccsem'                                             : 64 ,
        'spu'                                               : 64 ,
        'gfreel'                                            : 64 ,
        'timer'                                             : 64 ,
        'xev'                                               : 64 ,
        'rtype'                                             : 32 ,
        'gsem'                                              : 64 ,
        'ifreel'                                            : 64 ,
        'rinfo'                                             : 32 ,
        'swd'                                               : 32 ,
        'dbg0'                                              : 32 ,
        'cr0'                                               : 64 ,
        'cr1'                                               : 64 ,
        'cr2'                                               : 64 ,
        'cr3'                                               : 64 ,
        'cr4'                                               : 64 ,
        'cr5'                                               : 64 ,
        'cr6'                                               : 64 ,
        'cr7'                                               : 64 ,
        'cr8'                                               : 64 ,
        'cr9'                                               : 64 ,
        'cr10'                                              : 64 ,
        'cr11'                                              : 64 ,
        'cr12'                                              : 64 ,
        'cr13'                                              : 64 ,
        'cr14'                                              : 64 ,
        'cr15'                                              : 64 ,
        } ,
        'nP3700'                                            : {
        'r0_0'                                              : 8 ,
        'r0_1'                                              : 8 ,
        'r0_2'                                              : 8 ,
        'r0_3'                                              : 8 ,
        'r0_4'                                              : 8 ,
        'r0_5'                                              : 8 ,
        'r0_6'                                              : 8 ,
        'r0_7'                                              : 8 ,
        'r1_0'                                              : 8 ,
        'r1_1'                                              : 8 ,
        'r1_2'                                              : 8 ,
        'r1_3'                                              : 8 ,
        'r1_4'                                              : 8 ,
        'r1_5'                                              : 8 ,
        'r1_6'                                              : 8 ,
        'r1_7'                                              : 8 ,
        'r2_0'                                              : 8 ,
        'r2_1'                                              : 8 ,
        'r2_2'                                              : 8 ,
        'r2_3'                                              : 8 ,
        'r2_4'                                              : 8 ,
        'r2_5'                                              : 8 ,
        'r2_6'                                              : 8 ,
        'r2_7'                                              : 8 ,
        'r3_0'                                              : 8 ,
        'r3_1'                                              : 8 ,
        'r3_2'                                              : 8 ,
        'r3_3'                                              : 8 ,
        'r3_4'                                              : 8 ,
        'r3_5'                                              : 8 ,
        'r3_6'                                              : 8 ,
        'r3_7'                                              : 8 ,
        'r4_0'                                              : 8 ,
        'r4_1'                                              : 8 ,
        'r4_2'                                              : 8 ,
        'r4_3'                                              : 8 ,
        'r4_4'                                              : 8 ,
        'r4_5'                                              : 8 ,
        'r4_6'                                              : 8 ,
        'r4_7'                                              : 8 ,
        'r5_0'                                              : 8 ,
        'r5_1'                                              : 8 ,
        'r5_2'                                              : 8 ,
        'r5_3'                                              : 8 ,
        'r5_4'                                              : 8 ,
        'r5_5'                                              : 8 ,
        'r5_6'                                              : 8 ,
        'r5_7'                                              : 8 ,
        'r6_0'                                              : 8 ,
        'r6_1'                                              : 8 ,
        'r6_2'                                              : 8 ,
        'r6_3'                                              : 8 ,
        'r6_4'                                              : 8 ,
        'r6_5'                                              : 8 ,
        'r6_6'                                              : 8 ,
        'r6_7'                                              : 8 ,
        'r7_0'                                              : 8 ,
        'r7_1'                                              : 8 ,
        'r7_2'                                              : 8 ,
        'r7_3'                                              : 8 ,
        'r7_4'                                              : 8 ,
        'r7_5'                                              : 8 ,
        'r7_6'                                              : 8 ,
        'r7_7'                                              : 8 ,
        'tr0'                                               : 32 ,
        'tr1'                                               : 32 ,
        'tr2'                                               : 32 ,
        'tr3'                                               : 32 ,
        'tr4'                                               : 32 ,
        'tr5'                                               : 32 ,
        'tr6'                                               : 32 ,
        'tr7'                                               : 32 ,
        'tr8'                                               : 32 ,
        'tr9'                                               : 32 ,
        'tr10'                                              : 32 ,
        'tr11'                                              : 32 ,
        'tr12'                                              : 32 ,
        'tr13'                                              : 32 ,
        'tr14'                                              : 32 ,
        'tr15'                                              : 32 ,
        'zero'                                              : 32 ,
        'one'                                               : 32 ,
        'pc'                                                : 32 ,
        'tn'                                                : 32 ,
        'trm_drt_mask'                                      : 32 ,
        'fstt'                                              : 32 ,
        'mp0'                                               : 32 ,
        'mp1'                                               : 32 ,
        'mp2'                                               : 32 ,
        'mp3'                                               : 32 ,
        'tstt'                                              : 32 ,
        'cmd'                                               : 64 ,
        'crb0'                                              : 32 ,
        'crb1'                                              : 32 ,
        'spu'                                               : 64 ,
        'gfreel'                                            : 64 ,
        'timer'                                             : 64 ,
        'xev'                                               : 64 ,
        'rtype'                                             : 32 ,
        'gsem'                                              : 64 ,
        'ifreel'                                            : 64 ,
        'rinfo'                                             : 32 ,
        'swd'                                               : 32 ,
        'dbg0'                                              : 32 ,
        'cr0'                                               : 64 ,
        'cr1'                                               : 64 ,
        'cr2'                                               : 64 ,
        'cr3'                                               : 64 ,
        'cr4'                                               : 64 ,
        'cr5'                                               : 64 ,
        'cr6'                                               : 64 ,
        'cr7'                                               : 64 ,
        'cr8'                                               : 64 ,
        'cr9'                                               : 64 ,
        'cr10'                                              : 64 ,
        'cr11'                                              : 64 ,
        'cr12'                                              : 64 ,
        'cr13'                                              : 64 ,
        'cr14'                                              : 64 ,
        'cr15'                                              : 64 ,
        } ,
        }
    # ccsem        =>        64 ,


    reg = {}

    def __init__(self, *args) :
        name, type = args + ((None,) if len(args) == 1 else ())
        self._name = name
        self._value = CmmValueLattice('no_data')

        self._set_id()
        self._set_type(type)
        self._set_index()

    def new(self, type) :
        c = copy.deepcopy(self)
        return c

    def get_name(self) :
        return self._name

    def set_size(self, size) :
        print ("set_size TR " + str(size) + "\n")
        return self._type.set_size(size)

    def get_size(self) :
        print ("get_size TR " + str(self._type.get_size()) + "\n")
        return self._type.get_size()

    def _set_id(self) :
        self._id = self._name

    def _set_type(self, type = None) :
        if (type) :
            self._type = type
        else :
            self._type = CmmType('u', CmmReg.reg_size[CmmMisc.get_chip()][self._name] )

    def _set_index(self) :
        pass

    def set_bit_range(self, msb_bit, lsb_bit) :
        self._msb = msb_bit
        self._lsb = lsb_bit

    def splt_into_2(self) :
        size = self.get_size()

        if (size > 8) : size >>= 1

        return [ None, self.new(CmmType('u', size)) ]

    def is_a_reg(self) :
        return 1

    def intersects_with(self) :
        return 0
