from CmmSR import CmmSR

class CmmTR(CmmSR) :
    def is_a_tr_reg(self) :
        return 1

    reg_component = {}

    reg_component['tr0'] = {}
    reg_component['tr1'] = {}
    reg_component['tr2'] = {}
    reg_component['tr3'] = {}
    reg_component['tr4'] = {}
    reg_component['tr5'] = {}
    reg_component['tr6'] = {}
    reg_component['tr7'] = {}
    reg_component['tr8'] = {}
    reg_component['tr9'] = {}
    reg_component['tr10'] = {}
    reg_component['tr11'] = {}
    reg_component['tr12'] = {}
    reg_component['tr13'] = {}
    reg_component['tr14'] = {}
    reg_component['tr15'] = {}

    # def _build_reg_component_hash(self) :
    reg_component['tr0'][64]  = reg_component['tr0'][32]  = reg_component['tr0'][16]  = reg_component['tr0'][8]  = [ 'tr0' ]
    reg_component['tr1'][64]  = reg_component['tr1'][32]  = reg_component['tr1'][16]  = reg_component['tr1'][8]  = [ 'tr1' ]
    reg_component['tr2'][64]  = reg_component['tr2'][32]  = reg_component['tr2'][16]  = reg_component['tr2'][8]  = [ 'tr2' ]
    reg_component['tr3'][64]  = reg_component['tr3'][32]  = reg_component['tr3'][16]  = reg_component['tr3'][8]  = [ 'tr3' ]
    reg_component['tr4'][64]  = reg_component['tr4'][32]  = reg_component['tr4'][16]  = reg_component['tr4'][8]  = [ 'tr4' ]
    reg_component['tr5'][64]  = reg_component['tr5'][32]  = reg_component['tr5'][16]  = reg_component['tr5'][8]  = [ 'tr5' ]
    reg_component['tr6'][64]  = reg_component['tr6'][32]  = reg_component['tr6'][16]  = reg_component['tr6'][8]  = [ 'tr6' ]
    reg_component['tr7'][64]  = reg_component['tr7'][32]  = reg_component['tr7'][16]  = reg_component['tr7'][8]  = [ 'tr7' ]
    reg_component['tr8'][64]  = reg_component['tr8'][32]  = reg_component['tr8'][16]  = reg_component['tr8'][8]  = [ 'tr8' ]
    reg_component['tr9'][64]  = reg_component['tr9'][32]  = reg_component['tr9'][16]  = reg_component['tr9'][8]  = [ 'tr9' ]
    reg_component['tr10'][64] = reg_component['tr10'][32] = reg_component['tr10'][16] = reg_component['tr10'][8] = [ 'tr10' ]
    reg_component['tr11'][64] = reg_component['tr11'][32] = reg_component['tr11'][16] = reg_component['tr11'][8] = [ 'tr11' ]
    reg_component['tr12'][64] = reg_component['tr12'][32] = reg_component['tr12'][16] = reg_component['tr12'][8] = [ 'tr12' ]
    reg_component['tr13'][64] = reg_component['tr13'][32] = reg_component['tr13'][16] = reg_component['tr13'][8] = [ 'tr13' ]
    reg_component['tr14'][64] = reg_component['tr14'][32] = reg_component['tr14'][16] = reg_component['tr14'][8] = [ 'tr14' ]
    reg_component['tr15'][64] = reg_component['tr15'][32] = reg_component['tr15'][16] = reg_component['tr15'][8] = [ 'tr15' ]

    reg_component['tr0'][64]  = [ 'tr0' , 'tr1' ]
    reg_component['tr2'][64]  = [ 'tr2' , 'tr3' ]
    reg_component['tr4'][64]  = [ 'tr4' , 'tr5' ]
    reg_component['tr6'][64]  = [ 'tr6' , 'tr7' ]
    reg_component['tr8'][64]  = [ 'tr8' , 'tr9' ]
    reg_component['tr10'][64] = [ 'tr10', 'tr11' ]
    reg_component['tr12'][64] = [ 'tr12', 'tr13' ]
    reg_component['tr14'][64] = [ 'tr14', 'tr15' ]

    @staticmethod
    def _get_reg_components(reg, size) :
        return CmmTR.reg_component[reg][size]

    def splt(self) :
        return [ CmmTR(x)  for x in CmmTR._get_reg_components(self.get_name(), self.get_size())]

    def splt_into_2(self) :
        size = self.get_size()

        if (size == 64) :
            index = (self.get_index() + 1) % 16

            return [ CmmTR(x)  for x in (self.get_name() , 'tr' + str(index))]
        else :
            if (size > 8) : size >>= 1

            return [ None, CmmTR( self.get_name(), CmmType('u', size)) ]

    def _set_index(self) :
        self._index = self._name[2:]

    def get_index(self) :
        return self._index

    def intersects_with(self, reg) :
        return reg.is_a_tr_reg() and self.get_index() == reg.get_index()
