import copy

class CmmType(object) :
    def __init__(self, sign, size = None, msb = None) :
        if not (msb) : msb = 0
        # $lsb = 0 unless ($lsb) ;

        # my @caller ;

        # if (not defined $size) {
        # for (0 .. 7) {
        # @caller = caller $_ ;
        # print ($_ . " " . @caller . "\n") ;
        # }
        # }

        lsb = msb + size - 1
        # my $msb = $lsb + $size - 1 ;

        self._sign = sign
        self._def_size = size
        self._size = size
        self._lsb = lsb
        self._msb = msb
        self._field = {}
        self._static_field = []
        self._dynamic_field = []

    def new(self) :
        c = copy.deepcopy(self)
        return c

    def is_void(self) :
        return self._size == 0

    def get_sign(self) :
        return self._sign

    def set_signed(self) :
        self._sign = 's'

    def is_signed(self) :
        return (1) if self._sign == 's' else (0)

    def set_unsigned(self) :
        self._sign = 'u'

    def is_unsigned(self) :
        return (1) if self._sign == 'u' else (0)

    def get_msb(self) :
        return self._msb

    def get_lsb(self) :
        return self._lsb

    def set_bit_range(self, msb, lsb) :
        self._msb = msb
        self._lsb = lsb
        self._size = lsb - msb + 1
        # $self->{_size} = $msb - $lsb + 1 ;

        for lv in self._field.itervalues() :
            lv.shift_bit_range_by(msb)

    def get_bit_range(self, field = None, *fields) :
        if (field) :
            return self._field[field].get_bit_range(*fields)
        else :
            return [self._msb, self._lsb]

    def shift_bit_range_by(self, shft) :
        self._msb += shft
        self._lsb += shft

        for lv in self._field.itervalues() :
            lv.shift_bit_range_by(self._msb)

    def is_nonalligned(self) :
        # $self->{_lsb} & 0x7
        # print ("nonalligned lsb = " . $self->{_lsb} . "\n") ;
        # print ("nonalligned msb = " . $self->{_msb} . "\n") ;
        return (self._msb & 0x7) or ((self._lsb + 1) & 0x7)

    def set_field(self, field_name, field_type) :
        self._field[field_name] = field_type

    def set_size(self, size) :
        print ("set_size TT " + str(size) + "\n")

        self._size = size
        self._msb = self._lsb - size + 1

    def get_size(self) :
        print ("get_size TT " + str(self._size) + "\n")
        return self._size

    def get_def_size(self) :
        return self._def_size

    def set_static_field(self, msb, lsb) :
        self._static_field += [[ msb, lsb ]]

    def set_dynamic_field(self, msb, lsb) :
        self._dynamic_field += [[ msb, lsb ]]

    def set_static_fields(self, static_field) :
        self._static_field = static_field

    def set_dynamic_fields(self, dynamic_field) :
        self._dynamic_field = dynamic_field

    def get_static_fields(self) :
        return self._static_field

    def get_dynamic_fields(self) :
        return self._dynamic_field

    def get_minimal_static_field_size(self) :
        min = 64
        tmp = None

        for lv in self._static_field :
            tmp = lv[0] - lv[1]
            if (min > tmp) :
                min = tmp

        return min

    def get_minimal_dynamic_field_size(self) :
        min = 64
        tmp = None

        for lv in self._dynamic_field :
            tmp = lv[0] - lv[1]
            if (min > tmp) :
                min = tmp

        return min
