import copy
from CmmConst import CmmConst
from CmmType import CmmType

class CmmValueLattice(CmmConst) :
    big_mask = 0xffffffff00000000L

    def __init__(self, value) :
        size = 0

        if (value != 'no_data' and value != 'multiple_data') :
            size = 8

            if (value & CmmValueLattice.big_mask) :
                # print "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n" ;
                # print ("value = " . $value . "\n") ;
                size = 64
            elif (value & 0xffff0000) :
                size = 32
            elif (value & 0xff00) :
                size = 16

        self.set_value(value)
        self.set_type(CmmType('u', size))

    def new(self) :
        c = copy.deepcopy(self)
        return c

    def is_max(self) :
        return self._value == 'multiple_data'

    def is_min(self) :
        return self._value == 'no_data'

    def is_ordinary_constant(self) :
        return self.get_size()

    def compare(self, op1, op2) :
        # print ("op1 is " . @{[ ref($op1) ]} . " " . $op1 . "\n") ;
        # print ("op2 is " . @{[ ref($op2) ]} . " " . $op2 . "\n") ;

        if ((op1.is_max() and not op2.is_max()) or (not op1.is_min() and op2.is_min())) :
            return 1
        elif ((op1.is_min() and not op2.is_min()) or (not op1.is_max() and op2.is_max())) :
            return - 1
        else :
            return 0
