class CmmWarning(object) :
    _wrn_msg_list = []

    @staticmethod
    def _gen_wrn_msg(filename, line, warn_message) :
        return "Warning => file " + filename + ", line " + str(line) + " : " + warn_message

    @staticmethod
    def hash0(filename, line, function, arg) :
        CmmWarning._wrn_msg_list += [CmmWarning._gen_wrn_msg(filename, line, ("Argument '" + arg + "' in function '" + function + "' shadows global variable '" + arg + "'.\n"))]
    @staticmethod
    def hash1(filename, line, function, var) :
        CmmWarning._wrn_msg_list += [CmmWarning._gen_wrn_msg(filename, line, ("Variable '" + var + "' in function '" + function + "' shadows global variable '" + var + "'.\n"))]
    @staticmethod
    def hash2(filename, line) :
        CmmWarning._wrn_msg_list += [CmmWarning._gen_wrn_msg(filename, line, "Overflow in implicit constant conversion.\n")]

    _warning_message = {
        'WARN_ARG_SHADOWS_GLOB_VAR'                         : hash0,
        'WARN_VAR_SHADOWS_GLOB_VAR'                         : hash1,
        'WARN_OVERFLOW_IN_IMPLICIT_CONSTANT_CONVERSION'     : hash2,
        }

    @classmethod
    def warning_message(cls, wrn_type, *args) :
        return cls._warning_message[wrn_type](*args)

    @classmethod
    def prnt(cls) :
        for x in cls._wrn_msg_list :
            print x

        cls._wrn_msg_list = []
