#include <iostream>
#include "cmm_error.h"

enum {
MAX_FILENAME_LENGTH = 100
};

int lineno = 0;
char filename[MAX_FILENAME_LENGTH + 1] = "";

void error(cmm_error error_id, const char *pc_comment)
{
	std::cerr << "################################################################################" << std::endl;
	std::cerr << "error" ;

	if (filename && filename[0]) {
	  std::cerr << " in file '" << filename << "', line " << lineno ;
	}

	std::cerr << " : " ;

	switch (error_id) {
		case ERROR_EOF_IN_COMMENT		:
							 std::cerr << "end-of-file in a comment" ;
							 break ;
		case ERROR_INVALID_INCLUDE_DIRECTIVE	:
							 std::cerr << "invalid '#include' directive" ;
							 break ;
		case ERROR_INVALID_INCLUDE_FILENAME	:
							 std::cerr << "invalid filename in '#include' directive" ;
							 break ;
		case ERROR_INCLUDE_LOOP			:
							 std::cerr << "file inclusion loop" ;
							 break ;
		case ERROR_CLOSING_CURLY_BRACKET_MISSING:
							 std::cerr << "'}' is missing at the end of the file" ;
							 break ;
		case ERROR_UNEXPECTED_CHARACTER		:
							 std::cerr << "unexpected character " ;
							 break ;
		case ERROR_CANNOT_OPEN_FILE		:
							 std::cerr << "cannot open file " ;
							 break ;
	}

	std::cerr << pc_comment << '\n' ;
}
