/*
 * This file was generated by ./buildpl.pl on Tue Jan 22 22:49:25 PST 2008
 */

%{
// #include <ctype.h>
// #include <stdio.h>
#include "Python.h"
#include <iostream>
#include <string>

#include "parser.h"
#include "cmm_error.h"

extern int lineno;
extern char filename[];
static int scopeno = 0;
static int auxiliary_token = 0;
static bool eof = false;

static int semantic_value_set = 0;
static int process_eof();
static int process_unexpected_character();
static int process_token(int token);
%}

%x comment
%%

\/\*													{ BEGIN(comment); }
<comment>[^*\n]*										{}
<comment>\*+[^*/\n]*									{}
<comment>\n												{ lineno++; }
<comment>\*+\/											{ BEGIN(INITIAL); }
<comment><<EOF>>										{ error(ERROR_EOF_IN_COMMENT, ""); yyterminate(); }
^#\ [1-9][0-9]*\ \"[a-zA-Z_\.][a-zA-Z_\.0-9]*\".*\n		{ sscanf(yytext, "# %d \"%s", &lineno, filename); *(strchr(filename, '"')) = '\0'; }
\n														{ lineno++; }
\/\/.*													{}
[\t\f\v\r ]+											{ /* Ignore whitespace. */ }

"{"				{ return process_token('{'); }
"}"				{ return process_token('}'); }
"["				{ return process_token('['); }
"]"				{ return process_token(']'); }
"("				{ return process_token('('); }
")"				{ return process_token(')'); }
";"				{ return process_token(';'); }
":"				{ return process_token(':'); }
"?"				{ return process_token('?'); }
"."				{ return process_token('.'); }
"+"				{ return process_token('+'); }
"-"				{ return process_token('-'); }
"^"				{ return process_token('^'); }
"&"				{ return process_token('&'); }
"|"				{ return process_token('|'); }
"~"				{ return process_token('~'); }
"!"				{ return process_token('!'); }
"="				{ return process_token('='); }
"<"				{ return process_token('<'); }
">"				{ return process_token('>'); }
"+="			{ return process_token(ADDEQ); }
"-="			{ return process_token(SUBEQ); }
"^="			{ return process_token(XOREQ); }
"&="			{ return process_token(ANDEQ); }
"|="			{ return process_token(OREQ); }
"<<"			{ return process_token(SHLEFT); }
">>"			{ return process_token(SHRIGHT); }
"<<="			{ return process_token(SHLEQ); }
">>="			{ return process_token(SHREQ); }
"=="			{ return process_token(EQ); }
"!="			{ return process_token(NOTEQ); }
"<="			{ return process_token(LTEQ); }
">="			{ return process_token(GTEQ); }
"&&"			{ return process_token(ANDAND); }
"||"			{ return process_token(OROR); }
"++"			{ return process_token(PLUSPLUS); }
"--"			{ return process_token(MINUSMINUS); }
","				{ return process_token(','); }
mem				{ return process_token(MEM); }
break			{ return process_token(BREAK); }
char			{ return process_token(CHAR); }
continue		{ return process_token(CONTINUE); }
do				{ return process_token(DO); }
else			{ return process_token(ELSE); }
for				{ return process_token(FOR); }
goto			{ return process_token(GOTO); }
if				{ return process_token(IF); }
int				{ return process_token(INT); }
long			{ return process_token(LONG); }
return			{ return process_token(RETURN); }
short			{ return process_token(SHORT); }
signed			{ return process_token(SIGNED); }
struct			{ return process_token(STRUCT); }
union			{ return process_token(UNION); }
unsigned		{ return process_token(UNSIGNED); }
void			{ return process_token(VOID); }
while			{ return process_token(WHILE); }
inline			{ return process_token(INLINE); }
applet			{ return process_token(APPLET); }
interrupt		{ return process_token(INTERRUPT); }
r0				{ return process_token(R0); }
r1				{ return process_token(R1); }
r2				{ return process_token(R2); }
r3				{ return process_token(R3); }
r4				{ return process_token(R4); }
r5				{ return process_token(R5); }
r6				{ return process_token(R6); }
r7				{ return process_token(R7); }
r0_0			{ return process_token(R0_0); }
r0_1			{ return process_token(R0_1); }
r0_2			{ return process_token(R0_2); }
r0_3			{ return process_token(R0_3); }
r0_4			{ return process_token(R0_4); }
r0_5			{ return process_token(R0_5); }
r0_6			{ return process_token(R0_6); }
r0_7			{ return process_token(R0_7); }
r1_0			{ return process_token(R1_0); }
r1_1			{ return process_token(R1_1); }
r1_2			{ return process_token(R1_2); }
r1_3			{ return process_token(R1_3); }
r1_4			{ return process_token(R1_4); }
r1_5			{ return process_token(R1_5); }
r1_6			{ return process_token(R1_6); }
r1_7			{ return process_token(R1_7); }
r2_0			{ return process_token(R2_0); }
r2_1			{ return process_token(R2_1); }
r2_2			{ return process_token(R2_2); }
r2_3			{ return process_token(R2_3); }
r2_4			{ return process_token(R2_4); }
r2_5			{ return process_token(R2_5); }
r2_6			{ return process_token(R2_6); }
r2_7			{ return process_token(R2_7); }
r3_0			{ return process_token(R3_0); }
r3_1			{ return process_token(R3_1); }
r3_2			{ return process_token(R3_2); }
r3_3			{ return process_token(R3_3); }
r3_4			{ return process_token(R3_4); }
r3_5			{ return process_token(R3_5); }
r3_6			{ return process_token(R3_6); }
r3_7			{ return process_token(R3_7); }
r4_0			{ return process_token(R4_0); }
r4_1			{ return process_token(R4_1); }
r4_2			{ return process_token(R4_2); }
r4_3			{ return process_token(R4_3); }
r4_4			{ return process_token(R4_4); }
r4_5			{ return process_token(R4_5); }
r4_6			{ return process_token(R4_6); }
r4_7			{ return process_token(R4_7); }
r5_0			{ return process_token(R5_0); }
r5_1			{ return process_token(R5_1); }
r5_2			{ return process_token(R5_2); }
r5_3			{ return process_token(R5_3); }
r5_4			{ return process_token(R5_4); }
r5_5			{ return process_token(R5_5); }
r5_6			{ return process_token(R5_6); }
r5_7			{ return process_token(R5_7); }
r6_0			{ return process_token(R6_0); }
r6_1			{ return process_token(R6_1); }
r6_2			{ return process_token(R6_2); }
r6_3			{ return process_token(R6_3); }
r6_4			{ return process_token(R6_4); }
r6_5			{ return process_token(R6_5); }
r6_6			{ return process_token(R6_6); }
r6_7			{ return process_token(R6_7); }
r7_0			{ return process_token(R7_0); }
r7_1			{ return process_token(R7_1); }
r7_2			{ return process_token(R7_2); }
r7_3			{ return process_token(R7_3); }
r7_4			{ return process_token(R7_4); }
r7_5			{ return process_token(R7_5); }
r7_6			{ return process_token(R7_6); }
r7_7			{ return process_token(R7_7); }
tr0				{ return process_token(TR0); }
tr1				{ return process_token(TR1); }
tr2				{ return process_token(TR2); }
tr3				{ return process_token(TR3); }
tr4				{ return process_token(TR4); }
tr5				{ return process_token(TR5); }
tr6				{ return process_token(TR6); }
tr7				{ return process_token(TR7); }
tr8				{ return process_token(TR8); }
tr9				{ return process_token(TR9); }
tr10			{ return process_token(TR10); }
tr11			{ return process_token(TR11); }
tr12			{ return process_token(TR12); }
tr13			{ return process_token(TR13); }
tr14			{ return process_token(TR14); }
tr15			{ return process_token(TR15); }
mp0				{ return process_token(MP0); }
mp1				{ return process_token(MP1); }
mp2				{ return process_token(MP2); }
mp3				{ return process_token(MP3); }
pc				{ return process_token(PC); }
zero			{ return process_token(ZERO); }
one				{ return process_token(ONE); }
tn				{ return process_token(TN); }
trm_drt_mask	{ return process_token(TRM_DRT_MASK); }
fstt			{ return process_token(FSTT); }
tstt			{ return process_token(TSTT); }
cmd				{ return process_token(CMD); }
crb0			{ return process_token(CRB0); }
crb1			{ return process_token(CRB1); }
spu				{ return process_token(SPU); }
gfreel			{ return process_token(GFREEL); }
timer			{ return process_token(TIMER); }
xev				{ return process_token(XEV); }
rtype			{ return process_token(RTYPE); }
gsem			{ return process_token(GSEM); }
ifreel			{ return process_token(IFREEL); }
rinfo			{ return process_token(RINFO); }
swd				{ return process_token(SWD); }
dbg0			{ return process_token(DBG0); }
cr0				{ return process_token(CR0); }
cr1				{ return process_token(CR1); }
cr2				{ return process_token(CR2); }
cr3				{ return process_token(CR3); }
cr4				{ return process_token(CR4); }
cr5				{ return process_token(CR5); }
cr6				{ return process_token(CR6); }
cr7				{ return process_token(CR7); }
cr8				{ return process_token(CR8); }
cr9				{ return process_token(CR9); }
cr10			{ return process_token(CR10); }
cr11			{ return process_token(CR11); }
cr12			{ return process_token(CR12); }
cr13			{ return process_token(CR13); }
cr14			{ return process_token(CR14); }
cr15			{ return process_token(CR15); }
add				{ return process_token(ADD); }
addm			{ return process_token(ADDM); }
addc			{ return process_token(ADDC); }
addmc			{ return process_token(ADDMC); }
sub				{ return process_token(SUB); }
subm			{ return process_token(SUBM); }
subb			{ return process_token(SUBB); }
submb			{ return process_token(SUBMB); }
or				{ return process_token(OR); }
orm				{ return process_token(ORM); }
and				{ return process_token(AND); }
andm			{ return process_token(ANDM); }
xor				{ return process_token(XOR); }
xorm			{ return process_token(XORM); }
shl				{ return process_token(SHL); }
shlm			{ return process_token(SHLM); }
shr				{ return process_token(SHR); }
shrm			{ return process_token(SHRM); }
bitc			{ return process_token(BITC); }
bitcm			{ return process_token(BITCM); }
adi				{ return process_token(ADI); }
adim			{ return process_token(ADIM); }
sbi				{ return process_token(SBI); }
sbim			{ return process_token(SBIM); }
ori				{ return process_token(ORI); }
orim			{ return process_token(ORIM); }
andi			{ return process_token(ANDI); }
andim			{ return process_token(ANDIM); }
xori			{ return process_token(XORI); }
xorim			{ return process_token(XORIM); }
shli			{ return process_token(SHLI); }
shlim			{ return process_token(SHLIM); }
shri			{ return process_token(SHRI); }
shrim			{ return process_token(SHRIM); }
bitci			{ return process_token(BITCI); }
bitcim			{ return process_token(BITCIM); }
move			{ return process_token(MOVE); }
mviw			{ return process_token(MVIW); }
mvib			{ return process_token(MVIB); }
cmp				{ return process_token(CMP); }
cpiw			{ return process_token(CPIW); }
cpib			{ return process_token(CPIB); }
flo				{ return process_token(FLO); }
load			{ return process_token(LOAD); }
store			{ return process_token(STORE); }
stld			{ return process_token(STLD); }
cmdi			{ return process_token(CMDI); }
case			{ return process_token(CASE); }
btj				{ return process_token(BTJ); }
btjr			{ return process_token(BTJR); }
jsr				{ return process_token(JSR); }
frz				{ return process_token(FRZ); }
trm				{ return process_token(TRM); }
wxe				{ return process_token(WXE); }
nop				{ return process_token(NOP); }
[a-zA-Z_][a-zA-Z_0-9]*															{ return process_token(IDENTIFIER); }
([0-9]*|0[xX][0-9a-fA-F]+)(([uU][lL]?)|([lL][uU]?))?							{ return process_token(INTEGER); }
\"([^"\n]|\\\"|\\\n)*\"															{ return process_token(STRING); }

<<EOF>>				{ return process_eof(); }
.					{ return process_unexpected_character(); }

%%


static int set_semantic_value(const char *s, int size)
{
	PyObject *pValue = PyString_FromString(s);
// printf("s = %s, ", s);

	if (!pValue) {
		fprintf(stderr, "Cannot convert %s to Python object\n", s);
		yyterminate();
	}

	yylval = (YYSTYPE)pValue;
	semantic_value_set = 1;
// printf("yylval = %p\n", yylval);

	return 0;
}

static int process_eof()
{
	eof = 1;
printf("we are in '%s'\n", __func__);
	if (scopeno > 0) {
	  error(ERROR_CLOSING_CURLY_BRACKET_MISSING, "");
	}

	yyterminate();

	// return UNEXPECTED_CHAR;
}

static int process_unexpected_character()
{
	char error_message[4];
	sprintf(error_message, "'%c'", yytext[0]);

	error(ERROR_UNEXPECTED_CHARACTER, error_message);

	yyterminate();
}

static int process_token(int token)
{
	if (auxiliary_token) {
		token = auxiliary_token;
		auxiliary_token = 0;
	} else {
		switch (token) {
			case ADD		:
			case ADDC		:
			case ADDM		:
			case ADDMC		:
			case ADI		:
			case ADIM		:
			case AND		:
			case ANDI		:
			case ANDIM		:
			case ANDM		:
			case APPLET		:
			case BITC		:
			case BITCI		:
			case BITCIM		:
			case BITCM		:
			case BREAK		:
			case BTJ		:
			case BTJR		:
			case CASE		:
			case CHAR		:
			case CMDI		:
			case CMP		:
			case CONTINUE	:
			case CPIB		:
			case CPIW		:
			case DO			:
			case ELSE		:
			case FLO		:
			case FOR		:
			case FRZ		:
			case GOTO		:
			case IF			:
			case INLINE		:
			case INT		:
			case INTERRUPT	:
			case JSR		:
			case LOAD		:
			case LONG		:
			case MOVE		:
			case MVIB		:
			case MVIW		:
			case NOP		:
			case OR			:
			case ORI		:
			case ORIM		:
			case ORM		:
			case RETURN		:
			case SBI		:
			case SBIM		:
			case SHL		:
			case SHLI		:
			case SHLIM		:
			case SHLM		:
			case SHORT		:
			case SHR		:
			case SHRI		:
			case SHRIM		:
			case SHRM		:
			case SIGNED		:
			case STLD		:
			case STORE		:
			case STRUCT		:
			case SUB		:
			case SUBB		:
			case SUBM		:
			case SUBMB		:
			case TRM		:
			case UNION		:
			case UNSIGNED	:
			case VOID		:
			case WHILE		:
			case WXE		:
			case XOR		:
			case XORI		:
			case XORIM		:
			case XORM		:
					auxiliary_token = token;
					break;
			case '{'		:
					scopeno ++;
					break;
			case '}'		:
					scopeno --;
					break;
		}

		set_semantic_value(yytext, yyleng);

		if (auxiliary_token)
			yyless(0);
	}

	return token;
}

std::string get_sync_token()
{
	std::string sync_token("");

	if (auxiliary_token) {
	  switch (auxiliary_token) {
	  }
	}
	else {
	  sync_token = std::string(yytext);
	}

// std::cout << "sync_token = !" << sync_token << "!" << std::endl;

	return sync_token;
}

int at_eof()
{
	return eof;
}

int yywrap(void)
{
	return 1;
}

int lexer_constructor(const char *pc_in, const char *pc_out)
{
	if (!(yyin = fopen(pc_in, "r"))) {
		error(ERROR_CANNOT_OPEN_FILE, pc_in);
		return -1;
	}

	if (!(yyout = fopen(pc_out, "w"))) {
		fclose(yyin);
		error(ERROR_CANNOT_OPEN_FILE, pc_out);
		return -1;
	}

	lineno = 1;
	strcpy(filename, pc_in);

	return 0;
}

void lexer_destructor()
{
	  fclose(yyin);
	  fclose(yyout);
}
