#include <iostream>

extern int python_instance_constructor(char *python_module_name);
extern void python_instance_destructor(void);
extern bool lexer_constructor(const char *in, const char *out) ;
extern void lexer_destructor() ;
extern void yyparse(void) ;
extern void backend(char *) ;

int main(int argc, char *argv[])
{
	char *python_module_name = "CmmParserCallbacks";
    char *output_filename;

	if (argc != 3) {
	  // error_usage() ;
	  exit(1) ;
	}

	if (python_instance_constructor(python_module_name)) {
		// error();
		exit(1);
	}

	if (lexer_constructor(argv[1], argv[2])) {
		// error();
		exit(1);
	}

    output_filename = argv[2];

	yyparse();
    backend(output_filename);

	lexer_destructor() ;
	python_instance_destructor();

	return 0;
}
